package de.mdelab.expressiondialogs;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryContentProvider;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import de.mdelab.mlexpressions.MLStringExpression;
import de.mdelab.mlsdm.diagram.part.MlsdmDiagramEditorPlugin;

public class MlsdmEditStringExpressionDialog extends MlsdmEditExpressionDialog {

	public MlsdmEditStringExpressionDialog(Shell parent) {
		super(parent);
	}
	
	@Override
	protected void createCallActionHierarchie(){
		this.callActionHierarchie = new TreeViewer(this.upper, SWT.NONE); 

		GridData gridData = new GridData(GridData.FILL, GridData.FILL, true, true, 3, 1);
		gridData.minimumWidth = 500;
		gridData.minimumHeight = 200;
		gridData.widthHint = 500;
		gridData.heightHint = 200;
		this.callActionHierarchie.getTree().setLayoutData(gridData);
		this.callActionHierarchie.setContentProvider(new AdapterFactoryContentProvider(MlsdmDiagramEditorPlugin.getInstance()
				.getItemProvidersAdapterFactory()));
		this.callActionHierarchie.setLabelProvider(new AdapterFactoryLabelProvider.ColorProvider(MlsdmDiagramEditorPlugin
				.getInstance().getItemProvidersAdapterFactory(), this.callActionHierarchie));
		//TODO:??
		//JOptionPane.showInputDialog("MlsdmEditExpr ##### " + this.expressionOwner);
		if (this.expressionOwner!=null)
		{
			this.callActionHierarchie.setInput(this.expressionOwner);
			ViewerFilter[] viewerFilters = new ViewerFilter[1];
			viewerFilters[0] = new ViewerFilter()
			{

				@Override
				public boolean select(Viewer viewer, Object parentElement, Object element)
				{
					if (element instanceof MLStringExpression && element != MlsdmEditStringExpressionDialog.this.expression)
						return false;
					
					EObject container = (EObject) element;
					while (container!=null && container != MlsdmEditStringExpressionDialog.this.expression)
						container = container.eContainer();
					if (container == MlsdmEditStringExpressionDialog.this.expression)
						return true;
					return false;
				}
			};
			this.callActionHierarchie.setFilters(viewerFilters);
		}

		// creating Listener for the TreeItems
		SelectionListener stdTreeItemlistener = createSelectionListener();
		this.callActionHierarchie.getTree().addSelectionListener(stdTreeItemlistener);

	}
	@Override
	protected Control createDialogArea(Composite parent)
	{
		return super.createDialogArea(parent);
	}
}
