package de.mdelab.expressiondialogs.actions;

import java.util.List;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.ui.IObjectActionDelegate;

import de.mdelab.expressiondialogs.CommonEditParametersDialog;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.InitialNode;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNodeEditPart;

public class CustomEditParametersAction extends CustomAbstractActionDelegate implements IObjectActionDelegate
{

	protected CommonEditParametersDialog	editParamsDialog;

	@Override
	protected void doRun(IProgressMonitor progressMonitor)
	{
		editParamsDialog = new CommonEditParametersDialog(null);
		editParamsDialog.setActivity((Activity) this.getInitialNode().getActivityNodeContainer());
		editParamsDialog.setInitialNodeEditPart(this.getInitialNodeEditPart());
		editParamsDialog.open();
		this.getInitialNodeEditPart().addNotify();
		List<?> l = this.getInitialNodeEditPart().getParent().getChildren();
		for (int i = 0; i< l.size();i++){
			if (l.get(i) instanceof ActivityFinalNodeEditPart){
				((ActivityFinalNodeEditPart)l.get(i)).addNotify();
			}
		}
	}

	protected InitialNode getInitialNode()
	{
		return (InitialNode) ((View) ((InitialNodeEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
	}

	protected InitialNodeEditPart getInitialNodeEditPart()
	{
		return (InitialNodeEditPart) getStructuredSelection().getFirstElement();
	}

}
