package de.mdelab.expressiondialogs.actions;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.CompoundCommand;
import org.eclipse.emf.common.command.UnexecutableCommand;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.SetCommand;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.commands.core.command.AbstractTransactionalCommand;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.window.Window;

import de.mdelab.expressiondialogs.MlsdmEditExpressionDialog;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlexpressions.MLStringExpression;
import de.mdelab.mlexpressions.MlexpressionsFactory;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityEdgeGuardEnum;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEdgeEditPart;

public class EditActivityEdgeGuardExpressionAction extends EditExpressionAction
{

	@Override
	protected EClassifier getExpectedClassifier()
	{
		return EcorePackage.eINSTANCE.getEBoolean();
	}

	@Override
	protected MLExpression getExpression()
	{
		MLExpression exp = (MLExpression) ((ActivityEdge) this.getExpressionOwner()).getGuardExpression();
		//If there is no expression, create one
		if (exp == null){
			MLStringExpression exp2 = null;
			exp2 = MlexpressionsFactory.eINSTANCE.createMLStringExpression();
			exp2.setExpressionLanguageID("OCL");
			CompoundCommand cc = new CompoundCommand();
			ActivityEdge ae = (ActivityEdge) this.getExpressionOwner();
			TransactionalEditingDomain domain = TransactionUtil.getEditingDomain(ae);
			cc.append(domain.createCommand(SetCommand.class,
						new CommandParameter(ae, MlsdmPackage.eINSTANCE.getActivityEdge_GuardExpression(),
								exp2)));
			Command command = cc.unwrap();
			if (!command.equals(UnexecutableCommand.INSTANCE))
			{
				domain.getCommandStack().execute(command);
			}
			exp = exp2;
		}
		return exp;
	}
//
//	@Override
//	protected TransactionalEditingDomain getEditingDomain()
//	{
//		return ((ActivityEdgeEditPart) getStructuredSelection().getFirstElement()).getEditingDomain();
//	}

//	@Override
//	protected void setNewExpression(final MLExpression newExpression)
//	{
//		final ActivityEdge activityEdge = (ActivityEdge) this.getExpressionOwner();
//		AbstractTransactionalCommand command = new AbstractTransactionalCommand(getEditingDomain(), "Set GuardExpression",
//				null)
//		{
//			protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException
//			{
//				activityEdge.setGuardExpression(newExpression);
//				activityEdge.setGuardType(ActivityEdgeGuardEnum.BOOLEAN);
				/*ActivityEdgeGuardEnum newGuard = Utility.String2GuardEnum(actEdgeGuardValue);
				
				if (newGuard != activityEdge.getGuardType())
				{
					activityEdge.setGuardType(newGuard);

					if (activityEdge.getGuardType() == ActivityEdgeGuardEnum.BOOLEAN)
					{
					//JOptionPane.showInputDialog(newGuard);
						MlsdmEditExpressionDialog editExpressionDialog = new MlsdmEditExpressionDialog(null);
						editExpressionDialog.setExpectedClassifier(EcorePackage.eINSTANCE.getEBoolean());
						editExpressionDialog.setExpressionOwner(activityEdge);
						if (activityEdge.getGuardExpression()==null)
						{
							MLStringExpression exp2 = null;
							exp2 = MlexpressionsFactory.eINSTANCE.createMLStringExpression();
							exp2.setExpressionLanguageID("OCL");
							activityEdge.setGuardExpression(exp2);
							editExpressionDialog.setExpression(exp2);
						}
						else
						{
							editExpressionDialog.setExpression(activityEdge.getGuardExpression());
						}
						editExpressionDialog.setStructuralFeature(MlsdmPackage.eINSTANCE.getActivityEdge_GuardExpression());

						if (editExpressionDialog.open() == Window.OK)
						{			

							activityEdge.setGuardExpression(editExpressionDialog.getExpression());
						}
						else
						{
							activityEdge.setGuardType(ActivityEdgeGuardEnum.NONE);
						}
					}
					else
					{
						activityEdge.setGuardExpression(null);
					}
				}*/
				//JOptionPane.showInputDialog("2");
//
//				return CommandResult.newOKCommandResult();
//			}
//		};
//
//		execute(command);
//
//
//	}
	
	@Override
	protected void doRun(IProgressMonitor progressMonitor){
	final ActivityEdge activityEdge = (ActivityEdge) this.getExpressionOwner();
	AbstractTransactionalCommand command = new AbstractTransactionalCommand(getEditingDomain(), "Set GuardExpression",
			null)
	{
		protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException
		{
			MlsdmEditExpressionDialog editExpressionDialog = new MlsdmEditExpressionDialog(null);
			editExpressionDialog.setExpectedClassifier(EcorePackage.eINSTANCE.getEBoolean());
			editExpressionDialog.setExpressionOwner(activityEdge);
			if (activityEdge.getGuardExpression()==null)
			{
				MLStringExpression exp2 = null;
				exp2 = MlexpressionsFactory.eINSTANCE.createMLStringExpression();
				exp2.setExpressionLanguageID("OCL");
				activityEdge.setGuardExpression(exp2);
				editExpressionDialog.setExpression(exp2);
			}
			else
			{
				editExpressionDialog.setExpression(activityEdge.getGuardExpression());
			}
			editExpressionDialog.setStructuralFeature(MlsdmPackage.eINSTANCE.getActivityEdge_GuardExpression());

			if (editExpressionDialog.open() == Window.OK)
			{			

				activityEdge.setGuardExpression(editExpressionDialog.getExpression());
			}
			else
			{
				activityEdge.setGuardType(ActivityEdgeGuardEnum.NONE);
			}

			return CommandResult.newOKCommandResult();
		}
	};
	execute(command);
	((ActivityEdgeEditPart) getStructuredSelection().getFirstElement()).addNotify();
}
	@Override
	protected EClassifier getContextClassifier()
	{
		// No context classifier can be specified.
		return null;
	}

	//@Override
	protected Activity getActivity()
	{
		return (Activity) this.getExpressionOwner().eContainer();
	}

	@Override
	protected EObject getExpressionOwner()
	{
		return ((View) ((ActivityEdgeEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
	}

	@Override
	protected void prepareDialog()
	{
		super.prepareDialog();
		editExpressionDialog.setActivity(getActivity());
		editExpressionDialog.setStructuralFeature(MlsdmPackage.eINSTANCE.getActivityEdge_GuardExpression());
	}
}
