package de.mdelab.expressiondialogs.actions;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.CompoundCommand;
import org.eclipse.emf.common.command.UnexecutableCommand;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.SetCommand;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.eclipse.gmf.runtime.diagram.ui.editparts.CompartmentEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlexpressions.MLStringExpression;
import de.mdelab.mlexpressions.MlexpressionsFactory;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternObject;

public class EditAttributeAssignmentExpressionAction extends EditExpressionAction
{

	@Override
	protected EClassifier getExpectedClassifier()
	{
		EStructuralFeature feature = ((AttributeAssignment) this.getExpressionOwner()).getFeature();

		if (feature != null)
		{
			return feature.getEType();
		}
		else
		{
			return null;
		}
	}

	@Override
	protected MLExpression getExpression() {
		MLExpression expr = getExpressionOwner().getAssignmentExpression();
		
		if (expr == null){
			MLStringExpression exp2 = null;
			exp2 = MlexpressionsFactory.eINSTANCE.createMLStringExpression();
			exp2.setExpressionLanguageID("OCL");
			CompoundCommand cc = new CompoundCommand();
			AttributeAssignment aa = (AttributeAssignment) this.getExpressionOwner();
			TransactionalEditingDomain domain = TransactionUtil.getEditingDomain(aa);
			cc.append(domain.createCommand(SetCommand.class,
						new CommandParameter(aa, MlstorypatternsPackage.eINSTANCE.getAttributeAssignment_AssignmentExpression(),
								exp2)));
			Command command = cc.unwrap();
			if (!command.equals(UnexecutableCommand.INSTANCE))
			{
				domain.getCommandStack().execute(command);
			}
			expr = exp2;
		}

		return expr;
	}
//
//	@Override
//	protected TransactionalEditingDomain getEditingDomain()
//	{
//		return ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getEditingDomain();
//	}

//	@Override
//	protected void setNewExpression(MLExpression newExpression)
//	{
//		AttributeAssignment aa = (AttributeAssignment) this.getExpressionOwner();
//
//		aa.setAssignmentExpression(newExpression);
//	}

	@Override
	protected EClassifier getContextClassifier()
	{
		return ((StoryPatternObject) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent().getParent()
				.getModel()).getElement()).getType();
	}

	//@Override
	protected Activity getActivity()
	{
		EObject container = ((StoryPatternObject) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent()
				.getParent().getModel()).getElement()).eContainer();

		while (!(container instanceof Activity))
		{
			container = container.eContainer();
		}

		return (Activity) container;
	}

	@Override
	protected AttributeAssignment getExpressionOwner() {
		return (AttributeAssignment) ((View) ((IGraphicalEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
	}

	@Override
	protected void prepareDialog()
	{
		super.prepareDialog();
		editExpressionDialog.setActivity(getActivity());
		editExpressionDialog.setStructuralFeature( MlstorypatternsPackage.Literals.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION );
	}
}
