package de.mdelab.expressiondialogs.actions;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.gmf.runtime.diagram.ui.editparts.CompartmentEditPart;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;

public class EditCallActionExpressionAction extends EditExpressionAction
{
	
	@Override
	protected EClassifier getExpectedClassifier()
	{
		return EcorePackage.eINSTANCE.getEBoolean();
	}

	@Override
	protected MLExpression getExpression()
	{
		return (MLExpression) ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getModel()).getElement();
	}
//
//	@Override
//	protected TransactionalEditingDomain getEditingDomain()
//	{
//		return ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getEditingDomain();
//	}
//
//	@Override
//	protected void setNewExpression(MLExpression newExpression)
//	{
//		MLExpression oldExpression = getExpression();
//		ExpressionActivityNode ean = (ExpressionActivityNode) oldExpression.eContainer();
//
//		//ean.setExpression(newExpression);
//	}

	@Override
	protected EClassifier getContextClassifier()
	{
		// For expression activity nodes, no context classifier can be
		// specified.
		return null;
	}

	//@Override
	protected Activity getActivity()
	{
		EObject container = ((View) ((CompartmentEditPart) getStructuredSelection().getFirstElement()).getParent().getParent().getModel())
				.getElement();

		while (!(container instanceof Activity))
		{
			container = container.eContainer();
		}

		return (Activity) container;
	}

	@Override
	protected EObject getExpressionOwner()
	{
		return getExpression().eContainer();
	}

	@Override
	protected void prepareDialog()
	{
		super.prepareDialog();
		editExpressionDialog.setActivity(getActivity());
		editExpressionDialog.setRootContainer(getActivity());
		
		final EObject container = getExpressionOwner();
		
		final EStructuralFeature feature;
		
		if  ( MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT.isInstance( container ) ) {
			feature = MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__CONSTRAINTS;
		}
		else if ( MlstorypatternsPackage.Literals.STORY_PATTERN.isInstance( container ) ) {
			feature = MlstorypatternsPackage.Literals.STORY_PATTERN__CONSTRAINTS;
		}
		else {
			feature = MlsdmPackage.Literals.EXPRESSION_ACTIVITY_NODE__EXPRESSIONS;
		}

		editExpressionDialog.setStructuralFeature( feature );
	}
}
