/**
 */
package de.mdelab.mlsdm;

import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Acquire Edge</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * When the ActivityEdge is executed, a number of tokens is acquired from the Semaphore.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.AcquireEdge#getActivityEdge <em>Activity Edge</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.AcquireEdge#getSemaphore <em>Semaphore</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlsdm.MlsdmPackage#getAcquireEdge()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='ActivityEdgeSpecified'"
 * @generated
 */
public interface AcquireEdge extends SynchronizationEdge {
	/**
	 * Returns the value of the '<em><b>Activity Edge</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlsdm.ActivityEdge#getAcquireEdges <em>Acquire Edges</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activity Edge</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Activity Edge</em>' reference.
	 * @see #setActivityEdge(ActivityEdge)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getAcquireEdge_ActivityEdge()
	 * @see de.mdelab.mlsdm.ActivityEdge#getAcquireEdges
	 * @model opposite="acquireEdges" resolveProxies="false" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!AcquireEdge!activityEdge'"
	 * @generated
	 */
	ActivityEdge getActivityEdge();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.AcquireEdge#getActivityEdge <em>Activity Edge</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Activity Edge</em>' reference.
	 * @see #getActivityEdge()
	 * @generated
	 */
	void setActivityEdge(ActivityEdge value);

	/**
	 * Returns the value of the '<em><b>Semaphore</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlsdm.Semaphore#getAcquireEdges <em>Acquire Edges</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Semaphore</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Semaphore</em>' reference.
	 * @see #setSemaphore(Semaphore)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getAcquireEdge_Semaphore()
	 * @see de.mdelab.mlsdm.Semaphore#getAcquireEdges
	 * @model opposite="acquireEdges" resolveProxies="false" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!AcquireEdge!semaphore'"
	 * @generated
	 */
	Semaphore getSemaphore();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.AcquireEdge#getSemaphore
	 * <em>Semaphore</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Semaphore</em>' reference.
	 * @see #getSemaphore()
	 * @generated
	 */
	void setSemaphore(Semaphore value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='/**\n *\n * inv ActivityEdgeSpecified:\n *   let\n *     severity : Integer[1] = \'AcquireEdge::ActivityEdgeSpecified\'.getSeverity()\n *   in\n *     if severity &lt;= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.activityEdge &lt;&gt; null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Activity edge of acquire edge \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'AcquireEdge::ActivityEdgeSpecified\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n \052/\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%&gt;.getExecutor(this);\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.STR_AcquireEdge_c_c_ActivityEdgeSpecified);\nfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_0;\nif (le) {\n\tsymbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.STR_AcquireEdge_c_c_ActivityEdgeSpecified, this, (Object)null, diagnostics, context, (Object)null, severity_0, &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;'"
	 * @generated
	 */
	boolean ActivityEdgeSpecified(DiagnosticChain diagnostics,
			Map<Object, Object> context);

} // AcquireEdge
