/**
 */
package de.mdelab.mlsdm;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import de.mdelab.mlcore.MlcorePackage;

/**
 * <!-- begin-user-doc --> The <b>Package</b> for the model. It contains
 * accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each operation of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.mdelab.mlsdm.MlsdmFactory
 * @model kind="package"
 * @generated
 */
public interface MlsdmPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "mlsdm";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.mdelab.de/mlsdm/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "mlsdm";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	MlsdmPackage eINSTANCE = de.mdelab.mlsdm.impl.MlsdmPackageImpl.init();

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ActivityNodeContainerImpl <em>Activity Node Container</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.ActivityNodeContainerImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityNodeContainer()
	 * @generated
	 */
	int ACTIVITY_NODE_CONTAINER = 0;

	/**
	 * The feature id for the '<em><b>Edges</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_CONTAINER__EDGES = 0;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_CONTAINER__NODES = 1;

	/**
	 * The feature id for the '<em><b>Semaphores</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_CONTAINER__SEMAPHORES = 2;

	/**
	 * The feature id for the '<em><b>Synchronization Edges</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES = 3;

	/**
	 * The number of structural features of the '<em>Activity Node Container</em>' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_CONTAINER_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Activity Node Container</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_CONTAINER_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ActivityImpl <em>Activity</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.ActivityImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivity()
	 * @generated
	 */
	int ACTIVITY = 1;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY__NAME = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Edges</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY__EDGES = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY__NODES = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Semaphores</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY__SEMAPHORES = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 4;

	/**
	 * The feature id for the '<em><b>Synchronization Edges</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY__SYNCHRONIZATION_EDGES = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 5;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY__PARAMETERS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 6;

	/**
	 * The number of structural features of the '<em>Activity</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 7;

	/**
	 * The operation id for the '<em>Parameter Distinct Names</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY___PARAMETER_DISTINCT_NAMES__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>At Least One Final Node</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY___AT_LEAST_ONE_FINAL_NODE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Activity Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY___ACTIVITY_NAME__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>One Initial Node</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY___ONE_INITIAL_NODE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 3;

	/**
	 * The number of operations of the '<em>Activity</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 4;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ActivityNodeImpl
	 * <em>Activity Node</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ActivityNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityNode()
	 * @generated
	 */
	int ACTIVITY_NODE = 2;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE__OUTGOING_EDGES = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE__INCOMING_EDGES = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The number of structural features of the '<em>Activity Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 4;

	/**
	 * The number of operations of the '<em>Activity Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl
	 * <em>Activity Edge</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ActivityEdgeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityEdge()
	 * @generated
	 */
	int ACTIVITY_EDGE = 3;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE__SOURCE = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE__TARGET = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The feature id for the '<em><b>Guard Type</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE__GUARD_TYPE = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 4;

	/**
	 * The feature id for the '<em><b>Guard Expression</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE__GUARD_EXPRESSION = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 5;

	/**
	 * The feature id for the '<em><b>Acquire Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE__ACQUIRE_EDGES = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 6;

	/**
	 * The feature id for the '<em><b>Release Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE__RELEASE_EDGES = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 7;

	/**
	 * The feature id for the '<em><b>Assertion Expressions</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE__ASSERTION_EXPRESSIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 8;

	/**
	 * The number of structural features of the '<em>Activity Edge</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 9;

	/**
	 * The operation id for the '<em>Activity Edge Boolean Guard</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_BOOLEAN_GUARD__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Activity Edge Success Guard</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_SUCCESS_GUARD__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Activity Edge Guard Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_TYPE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>Activity Edge For Each Guard</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_FOR_EACH_GUARD__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>Activity Edge Source</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_SOURCE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 4;

	/**
	 * The operation id for the '<em>Activity Edge Else Guard</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_ELSE_GUARD__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 5;

	/**
	 * The operation id for the '<em>Activity Edge Target</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_TARGET__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 6;

	/**
	 * The operation id for the '<em>Activity Edge Failure Guard</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_FAILURE_GUARD__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 7;

	/**
	 * The operation id for the '<em>Activity Edge Guard Expression</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 8;

	/**
	 * The operation id for the '<em>Activity Edge No Guard Expression</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_NO_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 9;

	/**
	 * The operation id for the '<em>Activity Edge End Guard</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE___ACTIVITY_EDGE_END_GUARD__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 10;

	/**
	 * The number of operations of the '<em>Activity Edge</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 11;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.InitialNodeImpl
	 * <em>Initial Node</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.InitialNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getInitialNode()
	 * @generated
	 */
	int INITIAL_NODE = 4;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INITIAL_NODE__UUID = ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_NODE__ANNOTATIONS = ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_NODE__OUTGOING_EDGES = ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_NODE__INCOMING_EDGES = ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_NODE__ACTIVITY_NODE_CONTAINER = ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The number of structural features of the '<em>Initial Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_NODE_FEATURE_COUNT = ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Initial Node Incoming Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_NODE___INITIAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Initial Node Outgoing Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIAL_NODE___INITIAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 1;

	/**
	 * The number of operations of the '<em>Initial Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INITIAL_NODE_OPERATION_COUNT = ACTIVITY_NODE_OPERATION_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.FlowFinalNodeImpl <em>Flow Final Node</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.FlowFinalNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getFlowFinalNode()
	 * @generated
	 */
	int FLOW_FINAL_NODE = 5;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FLOW_FINAL_NODE__UUID = ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FINAL_NODE__ANNOTATIONS = ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FINAL_NODE__OUTGOING_EDGES = ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FINAL_NODE__INCOMING_EDGES = ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FINAL_NODE__ACTIVITY_NODE_CONTAINER = ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The number of structural features of the '<em>Flow Final Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FINAL_NODE_FEATURE_COUNT = ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Flow Final Node Incoming Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FINAL_NODE___FLOW_FINAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Flow Final Node Outgoing Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FINAL_NODE___FLOW_FINAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 1;

	/**
	 * The number of operations of the '<em>Flow Final Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FLOW_FINAL_NODE_OPERATION_COUNT = ACTIVITY_NODE_OPERATION_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ActivityFinalNodeImpl <em>Activity Final Node</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.ActivityFinalNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityFinalNode()
	 * @generated
	 */
	int ACTIVITY_FINAL_NODE = 6;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE__UUID = ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE__ANNOTATIONS = ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE__OUTGOING_EDGES = ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE__INCOMING_EDGES = ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE__ACTIVITY_NODE_CONTAINER = ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Output Parameter Values</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES = ACTIVITY_NODE_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Activity</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE__ACTIVITY = ACTIVITY_NODE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Activity Final Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE_FEATURE_COUNT = ACTIVITY_NODE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Incoming Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>No Output Parameter Value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE___NO_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Outgoing Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>One Output Parameter Value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE___ONE_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 3;

	/**
	 * The number of operations of the '<em>Activity Final Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_FINAL_NODE_OPERATION_COUNT = ACTIVITY_NODE_OPERATION_COUNT + 4;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ExpressionActivityNodeImpl <em>Expression Activity Node</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.ExpressionActivityNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getExpressionActivityNode()
	 * @generated
	 */
	int EXPRESSION_ACTIVITY_NODE = 7;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE__UUID = ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE__ANNOTATIONS = ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE__OUTGOING_EDGES = ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE__INCOMING_EDGES = ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER = ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE__NAME = ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expressions</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE__EXPRESSIONS = ACTIVITY_NODE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Expression Activity Node</em>' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE_FEATURE_COUNT = ACTIVITY_NODE_FEATURE_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>One Outgoing Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE___ONE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>One Incoming Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE___ONE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Expression Specified</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE___EXPRESSION_SPECIFIED__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 2;

	/**
	 * The number of operations of the '<em>Expression Activity Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_ACTIVITY_NODE_OPERATION_COUNT = ACTIVITY_NODE_OPERATION_COUNT
			+ 3;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.DecisionMergeNodeImpl <em>Decision Merge Node</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.DecisionMergeNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getDecisionMergeNode()
	 * @generated
	 */
	int DECISION_MERGE_NODE = 8;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE__UUID = ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE__ANNOTATIONS = ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE__OUTGOING_EDGES = ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE__INCOMING_EDGES = ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE__ACTIVITY_NODE_CONTAINER = ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The number of structural features of the '<em>Decision Merge Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE_FEATURE_COUNT = ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Incoming Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Multiple Edge Guards</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE___MULTIPLE_EDGE_GUARDS__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Single Edge Guard</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE___SINGLE_EDGE_GUARD__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>Outgoing Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 3;

	/**
	 * The number of operations of the '<em>Decision Merge Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECISION_MERGE_NODE_OPERATION_COUNT = ACTIVITY_NODE_OPERATION_COUNT + 4;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ForkJoinNodeImpl <em>Fork Join Node</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.ForkJoinNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getForkJoinNode()
	 * @generated
	 */
	int FORK_JOIN_NODE = 9;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FORK_JOIN_NODE__UUID = ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_JOIN_NODE__ANNOTATIONS = ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_JOIN_NODE__OUTGOING_EDGES = ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_JOIN_NODE__INCOMING_EDGES = ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_JOIN_NODE__ACTIVITY_NODE_CONTAINER = ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The number of structural features of the '<em>Fork Join Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_JOIN_NODE_FEATURE_COUNT = ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Incoming Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_JOIN_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Outgoing Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORK_JOIN_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 1;

	/**
	 * The number of operations of the '<em>Fork Join Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FORK_JOIN_NODE_OPERATION_COUNT = ACTIVITY_NODE_OPERATION_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.StoryNodeImpl
	 * <em>Story Node</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.StoryNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStoryNode()
	 * @generated
	 */
	int STORY_NODE = 10;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_NODE__UUID = ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE__ANNOTATIONS = ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE__OUTGOING_EDGES = ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE__INCOMING_EDGES = ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE__ACTIVITY_NODE_CONTAINER = ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_NODE__NAME = ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Story Pattern</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE__STORY_PATTERN = ACTIVITY_NODE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Semantics</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_NODE__SEMANTICS = ACTIVITY_NODE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Story Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE_FEATURE_COUNT = ACTIVITY_NODE_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Incoming Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>For Each Loop Body</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE___FOR_EACH_LOOP_BODY__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Story Pattern Specified</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE___STORY_PATTERN_SPECIFIED__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 2;

	/**
	 * The operation id for the '<em>Semantics Specified</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE___SEMANTICS_SPECIFIED__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>For Each Match Outgoing Edges</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE___FOR_EACH_MATCH_OUTGOING_EDGES__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 4;

	/**
	 * The operation id for the '<em>Single Match Outgoing Edges</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORY_NODE___SINGLE_MATCH_OUTGOING_EDGES__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 5;

	/**
	 * The number of operations of the '<em>Story Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STORY_NODE_OPERATION_COUNT = ACTIVITY_NODE_OPERATION_COUNT + 6;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.StructuredNodeImpl <em>Structured Node</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.StructuredNodeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStructuredNode()
	 * @generated
	 */
	int STRUCTURED_NODE = 11;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE__UUID = ACTIVITY_NODE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE__ANNOTATIONS = ACTIVITY_NODE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Outgoing Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE__OUTGOING_EDGES = ACTIVITY_NODE__OUTGOING_EDGES;

	/**
	 * The feature id for the '<em><b>Incoming Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE__INCOMING_EDGES = ACTIVITY_NODE__INCOMING_EDGES;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE__ACTIVITY_NODE_CONTAINER = ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Edges</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE__EDGES = ACTIVITY_NODE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE__NODES = ACTIVITY_NODE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Semaphores</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE__SEMAPHORES = ACTIVITY_NODE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Synchronization Edges</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE__SYNCHRONIZATION_EDGES = ACTIVITY_NODE_FEATURE_COUNT
			+ 3;

	/**
	 * The number of structural features of the '<em>Structured Node</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE_FEATURE_COUNT = ACTIVITY_NODE_FEATURE_COUNT + 4;

	/**
	 * The operation id for the '<em>Initial Node Contained</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE___INITIAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Final Node Contained</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE___FINAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP = ACTIVITY_NODE_OPERATION_COUNT
			+ 1;

	/**
	 * The number of operations of the '<em>Structured Node</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_NODE_OPERATION_COUNT = ACTIVITY_NODE_OPERATION_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.SemaphoreImpl <em>Semaphore</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.SemaphoreImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getSemaphore()
	 * @generated
	 */
	int SEMAPHORE = 12;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__NAME = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__ACTIVITY_NODE_CONTAINER = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Token Count</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__TOKEN_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The feature id for the '<em><b>Acquire Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__ACQUIRE_EDGES = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 4;

	/**
	 * The feature id for the '<em><b>Release Edges</b></em>' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__RELEASE_EDGES = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 5;

	/**
	 * The number of structural features of the '<em>Semaphore</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 6;

	/**
	 * The operation id for the '<em>Token Count Not Negative</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE___TOKEN_COUNT_NOT_NEGATIVE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Release Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE___RELEASE_EDGE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>Acquire Edge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE___ACQUIRE_EDGE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 2;

	/**
	 * The number of operations of the '<em>Semaphore</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 3;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.SynchronizationEdgeImpl <em>Synchronization Edge</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.SynchronizationEdgeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getSynchronizationEdge()
	 * @generated
	 */
	int SYNCHRONIZATION_EDGE = 13;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SYNCHRONIZATION_EDGE__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYNCHRONIZATION_EDGE__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Weight</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SYNCHRONIZATION_EDGE__WEIGHT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The number of structural features of the '<em>Synchronization Edge</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYNCHRONIZATION_EDGE_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>Weight Positive</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYNCHRONIZATION_EDGE___WEIGHT_POSITIVE__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The number of operations of the '<em>Synchronization Edge</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYNCHRONIZATION_EDGE_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 1;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.AcquireEdgeImpl
	 * <em>Acquire Edge</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.AcquireEdgeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getAcquireEdge()
	 * @generated
	 */
	int ACQUIRE_EDGE = 14;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACQUIRE_EDGE__UUID = SYNCHRONIZATION_EDGE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACQUIRE_EDGE__ANNOTATIONS = SYNCHRONIZATION_EDGE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACQUIRE_EDGE__ACTIVITY_NODE_CONTAINER = SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Weight</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACQUIRE_EDGE__WEIGHT = SYNCHRONIZATION_EDGE__WEIGHT;

	/**
	 * The feature id for the '<em><b>Activity Edge</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACQUIRE_EDGE__ACTIVITY_EDGE = SYNCHRONIZATION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Semaphore</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACQUIRE_EDGE__SEMAPHORE = SYNCHRONIZATION_EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Acquire Edge</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACQUIRE_EDGE_FEATURE_COUNT = SYNCHRONIZATION_EDGE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Weight Positive</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACQUIRE_EDGE___WEIGHT_POSITIVE__DIAGNOSTICCHAIN_MAP = SYNCHRONIZATION_EDGE___WEIGHT_POSITIVE__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Activity Edge Specified</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACQUIRE_EDGE___ACTIVITY_EDGE_SPECIFIED__DIAGNOSTICCHAIN_MAP = SYNCHRONIZATION_EDGE_OPERATION_COUNT
			+ 0;

	/**
	 * The number of operations of the '<em>Acquire Edge</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACQUIRE_EDGE_OPERATION_COUNT = SYNCHRONIZATION_EDGE_OPERATION_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ReleaseEdgeImpl
	 * <em>Release Edge</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlsdm.impl.ReleaseEdgeImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getReleaseEdge()
	 * @generated
	 */
	int RELEASE_EDGE = 15;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RELEASE_EDGE__UUID = SYNCHRONIZATION_EDGE__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELEASE_EDGE__ANNOTATIONS = SYNCHRONIZATION_EDGE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Activity Node Container</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELEASE_EDGE__ACTIVITY_NODE_CONTAINER = SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER;

	/**
	 * The feature id for the '<em><b>Weight</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RELEASE_EDGE__WEIGHT = SYNCHRONIZATION_EDGE__WEIGHT;

	/**
	 * The feature id for the '<em><b>Activity Edge</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RELEASE_EDGE__ACTIVITY_EDGE = SYNCHRONIZATION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Semaphore</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RELEASE_EDGE__SEMAPHORE = SYNCHRONIZATION_EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Release Edge</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELEASE_EDGE_FEATURE_COUNT = SYNCHRONIZATION_EDGE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Weight Positive</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELEASE_EDGE___WEIGHT_POSITIVE__DIAGNOSTICCHAIN_MAP = SYNCHRONIZATION_EDGE___WEIGHT_POSITIVE__DIAGNOSTICCHAIN_MAP;

	/**
	 * The operation id for the '<em>Activity Edge Specified</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELEASE_EDGE___ACTIVITY_EDGE_SPECIFIED__DIAGNOSTICCHAIN_MAP = SYNCHRONIZATION_EDGE_OPERATION_COUNT
			+ 0;

	/**
	 * The number of operations of the '<em>Release Edge</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RELEASE_EDGE_OPERATION_COUNT = SYNCHRONIZATION_EDGE_OPERATION_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.ActivityParameterImpl <em>Activity Parameter</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.ActivityParameterImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityParameter()
	 * @generated
	 */
	int ACTIVITY_PARAMETER = 16;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER__NAME = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER__TYPE = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER__DIRECTION = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The feature id for the '<em><b>Activity</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER__ACTIVITY = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 4;

	/**
	 * The number of structural features of the '<em>Activity Parameter</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 5;

	/**
	 * The operation id for the '<em>Direction Specified</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER___DIRECTION_SPECIFIED__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Type Specified</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 1;

	/**
	 * The number of operations of the '<em>Activity Parameter</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 2;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.impl.OutputParameterValueImpl <em>Output Parameter Value</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlsdm.impl.OutputParameterValueImpl
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getOutputParameterValue()
	 * @generated
	 */
	int OUTPUT_PARAMETER_VALUE = 17;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER_VALUE__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER_VALUE__ANNOTATIONS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER_VALUE__PARAMETER = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER_VALUE__EXPRESSION = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The feature id for the '<em><b>Activity Final Node</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The number of structural features of the '<em>Output Parameter Value</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER_VALUE_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 4;

	/**
	 * The operation id for the '<em>Expression Specfied</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER_VALUE___EXPRESSION_SPECFIED__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>Parameter Specfied</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER_VALUE___PARAMETER_SPECFIED__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 1;

	/**
	 * The number of operations of the '<em>Output Parameter Value</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUT_PARAMETER_VALUE_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 2;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.ActivityEdgeGuardEnum <em>Activity Edge Guard Enum</em>}' enum.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlsdm.ActivityEdgeGuardEnum
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityEdgeGuardEnum()
	 * @generated
	 */
	int ACTIVITY_EDGE_GUARD_ENUM = 18;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.StoryNodeSemanticsEnum <em>Story Node Semantics Enum</em>}' enum.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlsdm.StoryNodeSemanticsEnum
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStoryNodeSemanticsEnum()
	 * @generated
	 */
	int STORY_NODE_SEMANTICS_ENUM = 19;

	/**
	 * The meta object id for the '{@link de.mdelab.mlsdm.ActivityParameterDirectionEnum <em>Activity Parameter Direction Enum</em>}' enum.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @see de.mdelab.mlsdm.ActivityParameterDirectionEnum
	 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityParameterDirectionEnum()
	 * @generated
	 */
	int ACTIVITY_PARAMETER_DIRECTION_ENUM = 20;

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ActivityNodeContainer <em>Activity Node Container</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>Activity Node Container</em>'.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer
	 * @generated
	 */
	EClass getActivityNodeContainer();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlsdm.ActivityNodeContainer#getEdges <em>Edges</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer#getEdges()
	 * @see #getActivityNodeContainer()
	 * @generated
	 */
	EReference getActivityNodeContainer_Edges();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlsdm.ActivityNodeContainer#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Nodes</em>'.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer#getNodes()
	 * @see #getActivityNodeContainer()
	 * @generated
	 */
	EReference getActivityNodeContainer_Nodes();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlsdm.ActivityNodeContainer#getSemaphores <em>Semaphores</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Semaphores</em>'.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer#getSemaphores()
	 * @see #getActivityNodeContainer()
	 * @generated
	 */
	EReference getActivityNodeContainer_Semaphores();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlsdm.ActivityNodeContainer#getSynchronizationEdges <em>Synchronization Edges</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Synchronization Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityNodeContainer#getSynchronizationEdges()
	 * @see #getActivityNodeContainer()
	 * @generated
	 */
	EReference getActivityNodeContainer_SynchronizationEdges();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.Activity <em>Activity</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activity</em>'.
	 * @see de.mdelab.mlsdm.Activity
	 * @generated
	 */
	EClass getActivity();

	/**
	 * Returns the meta object for the containment reference list '
	 * {@link de.mdelab.mlsdm.Activity#getParameters <em>Parameters</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '
	 *         <em>Parameters</em>'.
	 * @see de.mdelab.mlsdm.Activity#getParameters()
	 * @see #getActivity()
	 * @generated
	 */
	EReference getActivity_Parameters();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.Activity#ParameterDistinctNames(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Parameter Distinct Names</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Parameter Distinct Names</em>' operation.
	 * @see de.mdelab.mlsdm.Activity#ParameterDistinctNames(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivity__ParameterDistinctNames__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.Activity#AtLeastOneFinalNode(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>At Least One Final Node</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>At Least One Final Node</em>' operation.
	 * @see de.mdelab.mlsdm.Activity#AtLeastOneFinalNode(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivity__AtLeastOneFinalNode__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.Activity#ActivityName(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Name</em>' operation.
	 * @see de.mdelab.mlsdm.Activity#ActivityName(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivity__ActivityName__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.Activity#OneInitialNode(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>One Initial Node</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>One Initial Node</em>' operation.
	 * @see de.mdelab.mlsdm.Activity#OneInitialNode(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivity__OneInitialNode__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ActivityNode <em>Activity Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activity Node</em>'.
	 * @see de.mdelab.mlsdm.ActivityNode
	 * @generated
	 */
	EClass getActivityNode();

	/**
	 * Returns the meta object for the reference list '{@link de.mdelab.mlsdm.ActivityNode#getOutgoingEdges <em>Outgoing Edges</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Outgoing Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityNode#getOutgoingEdges()
	 * @see #getActivityNode()
	 * @generated
	 */
	EReference getActivityNode_OutgoingEdges();

	/**
	 * Returns the meta object for the reference list '{@link de.mdelab.mlsdm.ActivityNode#getIncomingEdges <em>Incoming Edges</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Incoming Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityNode#getIncomingEdges()
	 * @see #getActivityNode()
	 * @generated
	 */
	EReference getActivityNode_IncomingEdges();

	/**
	 * Returns the meta object for the container reference '{@link de.mdelab.mlsdm.ActivityNode#getActivityNodeContainer <em>Activity Node Container</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the container reference '<em>Activity Node Container</em>'.
	 * @see de.mdelab.mlsdm.ActivityNode#getActivityNodeContainer()
	 * @see #getActivityNode()
	 * @generated
	 */
	EReference getActivityNode_ActivityNodeContainer();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ActivityEdge <em>Activity Edge</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activity Edge</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge
	 * @generated
	 */
	EClass getActivityEdge();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getSource <em>Source</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getSource()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_Source();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getTarget <em>Target</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getTarget()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_Target();

	/**
	 * Returns the meta object for the container reference '{@link de.mdelab.mlsdm.ActivityEdge#getActivityNodeContainer <em>Activity Node Container</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the container reference '<em>Activity Node Container</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getActivityNodeContainer()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_ActivityNodeContainer();

	/**
	 * Returns the meta object for the attribute '{@link de.mdelab.mlsdm.ActivityEdge#getGuardType <em>Guard Type</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Guard Type</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getGuardType()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EAttribute getActivityEdge_GuardType();

	/**
	 * Returns the meta object for the containment reference '
	 * {@link de.mdelab.mlsdm.ActivityEdge#getGuardExpression
	 * <em>Guard Expression</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for the containment reference '
	 *         <em>Guard Expression</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getGuardExpression()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_GuardExpression();

	/**
	 * Returns the meta object for the reference list '{@link de.mdelab.mlsdm.ActivityEdge#getAcquireEdges <em>Acquire Edges</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Acquire Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getAcquireEdges()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_AcquireEdges();

	/**
	 * Returns the meta object for the reference list '{@link de.mdelab.mlsdm.ActivityEdge#getReleaseEdges <em>Release Edges</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Release Edges</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getReleaseEdges()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_ReleaseEdges();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlsdm.ActivityEdge#getAssertionExpressions <em>Assertion Expressions</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Assertion Expressions</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdge#getAssertionExpressions()
	 * @see #getActivityEdge()
	 * @generated
	 */
	EReference getActivityEdge_AssertionExpressions();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeBooleanGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge Boolean Guard</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge Boolean Guard</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeBooleanGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeBooleanGuard__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeSuccessGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge Success Guard</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge Success Guard</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeSuccessGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeSuccessGuard__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeGuardType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge Guard Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge Guard Type</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeGuardType(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeGuardType__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeForEachGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge For Each Guard</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge For Each Guard</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeForEachGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeForEachGuard__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeSource(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge Source</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge Source</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeSource(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeSource__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeElseGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge Else Guard</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge Else Guard</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeElseGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeElseGuard__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeTarget(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge Target</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge Target</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeTarget(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeTarget__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeFailureGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge Failure Guard</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge Failure Guard</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeFailureGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeFailureGuard__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeGuardExpression(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge Guard Expression</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge Guard Expression</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeGuardExpression(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeGuardExpression__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeNoGuardExpression(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge No Guard Expression</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge No Guard Expression</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeNoGuardExpression(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeNoGuardExpression__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityEdge#ActivityEdgeEndGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge End Guard</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge End Guard</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityEdge#ActivityEdgeEndGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityEdge__ActivityEdgeEndGuard__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.InitialNode <em>Initial Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Initial Node</em>'.
	 * @see de.mdelab.mlsdm.InitialNode
	 * @generated
	 */
	EClass getInitialNode();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.InitialNode#InitialNodeIncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Initial Node Incoming Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Initial Node Incoming Edge</em>' operation.
	 * @see de.mdelab.mlsdm.InitialNode#InitialNodeIncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getInitialNode__InitialNodeIncomingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.InitialNode#InitialNodeOutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Initial Node Outgoing Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Initial Node Outgoing Edge</em>' operation.
	 * @see de.mdelab.mlsdm.InitialNode#InitialNodeOutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getInitialNode__InitialNodeOutgoingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.FlowFinalNode <em>Flow Final Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow Final Node</em>'.
	 * @see de.mdelab.mlsdm.FlowFinalNode
	 * @generated
	 */
	EClass getFlowFinalNode();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.FlowFinalNode#FlowFinalNodeIncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Flow Final Node Incoming Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Flow Final Node Incoming Edge</em>' operation.
	 * @see de.mdelab.mlsdm.FlowFinalNode#FlowFinalNodeIncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFlowFinalNode__FlowFinalNodeIncomingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.FlowFinalNode#FlowFinalNodeOutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Flow Final Node Outgoing Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Flow Final Node Outgoing Edge</em>' operation.
	 * @see de.mdelab.mlsdm.FlowFinalNode#FlowFinalNodeOutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getFlowFinalNode__FlowFinalNodeOutgoingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ActivityFinalNode <em>Activity Final Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activity Final Node</em>'.
	 * @see de.mdelab.mlsdm.ActivityFinalNode
	 * @generated
	 */
	EClass getActivityFinalNode();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlsdm.ActivityFinalNode#getOutputParameterValues <em>Output Parameter Values</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Output Parameter Values</em>'.
	 * @see de.mdelab.mlsdm.ActivityFinalNode#getOutputParameterValues()
	 * @see #getActivityFinalNode()
	 * @generated
	 */
	EReference getActivityFinalNode_OutputParameterValues();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlsdm.ActivityFinalNode#getActivity <em>Activity</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Activity</em>'.
	 * @see de.mdelab.mlsdm.ActivityFinalNode#getActivity()
	 * @see #getActivityFinalNode()
	 * @generated
	 */
	EReference getActivityFinalNode_Activity();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityFinalNode#IncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Incoming Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Incoming Edge</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityFinalNode#IncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityFinalNode__IncomingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityFinalNode#NoOutputParameterValue(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>No Output Parameter Value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>No Output Parameter Value</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityFinalNode#NoOutputParameterValue(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityFinalNode__NoOutputParameterValue__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityFinalNode#OutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Outgoing Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Outgoing Edge</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityFinalNode#OutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityFinalNode__OutgoingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityFinalNode#OneOutputParameterValue(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>One Output Parameter Value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>One Output Parameter Value</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityFinalNode#OneOutputParameterValue(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityFinalNode__OneOutputParameterValue__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ExpressionActivityNode <em>Expression Activity Node</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>Expression Activity Node</em>'.
	 * @see de.mdelab.mlsdm.ExpressionActivityNode
	 * @generated
	 */
	EClass getExpressionActivityNode();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlsdm.ExpressionActivityNode#getExpressions <em>Expressions</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Expressions</em>'.
	 * @see de.mdelab.mlsdm.ExpressionActivityNode#getExpressions()
	 * @see #getExpressionActivityNode()
	 * @generated
	 */
	EReference getExpressionActivityNode_Expressions();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ExpressionActivityNode#OneOutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>One Outgoing Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>One Outgoing Edge</em>' operation.
	 * @see de.mdelab.mlsdm.ExpressionActivityNode#OneOutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExpressionActivityNode__OneOutgoingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ExpressionActivityNode#OneIncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>One Incoming Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>One Incoming Edge</em>' operation.
	 * @see de.mdelab.mlsdm.ExpressionActivityNode#OneIncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExpressionActivityNode__OneIncomingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ExpressionActivityNode#ExpressionSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Expression Specified</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Expression Specified</em>' operation.
	 * @see de.mdelab.mlsdm.ExpressionActivityNode#ExpressionSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getExpressionActivityNode__ExpressionSpecified__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.DecisionMergeNode <em>Decision Merge Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Decision Merge Node</em>'.
	 * @see de.mdelab.mlsdm.DecisionMergeNode
	 * @generated
	 */
	EClass getDecisionMergeNode();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.DecisionMergeNode#IncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Incoming Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Incoming Edge</em>' operation.
	 * @see de.mdelab.mlsdm.DecisionMergeNode#IncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDecisionMergeNode__IncomingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.DecisionMergeNode#MultipleEdgeGuards(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Multiple Edge Guards</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Multiple Edge Guards</em>' operation.
	 * @see de.mdelab.mlsdm.DecisionMergeNode#MultipleEdgeGuards(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDecisionMergeNode__MultipleEdgeGuards__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.DecisionMergeNode#SingleEdgeGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Single Edge Guard</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Single Edge Guard</em>' operation.
	 * @see de.mdelab.mlsdm.DecisionMergeNode#SingleEdgeGuard(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDecisionMergeNode__SingleEdgeGuard__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.DecisionMergeNode#OutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Outgoing Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Outgoing Edge</em>' operation.
	 * @see de.mdelab.mlsdm.DecisionMergeNode#OutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getDecisionMergeNode__OutgoingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ForkJoinNode <em>Fork Join Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fork Join Node</em>'.
	 * @see de.mdelab.mlsdm.ForkJoinNode
	 * @generated
	 */
	EClass getForkJoinNode();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ForkJoinNode#IncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Incoming Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Incoming Edge</em>' operation.
	 * @see de.mdelab.mlsdm.ForkJoinNode#IncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getForkJoinNode__IncomingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ForkJoinNode#OutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Outgoing Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Outgoing Edge</em>' operation.
	 * @see de.mdelab.mlsdm.ForkJoinNode#OutgoingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getForkJoinNode__OutgoingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.StoryNode <em>Story Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Story Node</em>'.
	 * @see de.mdelab.mlsdm.StoryNode
	 * @generated
	 */
	EClass getStoryNode();

	/**
	 * Returns the meta object for the containment reference '{@link de.mdelab.mlsdm.StoryNode#getStoryPattern <em>Story Pattern</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Story Pattern</em>'.
	 * @see de.mdelab.mlsdm.StoryNode#getStoryPattern()
	 * @see #getStoryNode()
	 * @generated
	 */
	EReference getStoryNode_StoryPattern();

	/**
	 * Returns the meta object for the attribute '
	 * {@link de.mdelab.mlsdm.StoryNode#getSemantics <em>Semantics</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Semantics</em>'.
	 * @see de.mdelab.mlsdm.StoryNode#getSemantics()
	 * @see #getStoryNode()
	 * @generated
	 */
	EAttribute getStoryNode_Semantics();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.StoryNode#IncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Incoming Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Incoming Edge</em>' operation.
	 * @see de.mdelab.mlsdm.StoryNode#IncomingEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryNode__IncomingEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.StoryNode#ForEachLoopBody(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>For Each Loop Body</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>For Each Loop Body</em>' operation.
	 * @see de.mdelab.mlsdm.StoryNode#ForEachLoopBody(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryNode__ForEachLoopBody__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.StoryNode#StoryPatternSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Story Pattern Specified</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Story Pattern Specified</em>' operation.
	 * @see de.mdelab.mlsdm.StoryNode#StoryPatternSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryNode__StoryPatternSpecified__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.StoryNode#SemanticsSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Semantics Specified</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Semantics Specified</em>' operation.
	 * @see de.mdelab.mlsdm.StoryNode#SemanticsSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryNode__SemanticsSpecified__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.StoryNode#ForEachMatchOutgoingEdges(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>For Each Match Outgoing Edges</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>For Each Match Outgoing Edges</em>' operation.
	 * @see de.mdelab.mlsdm.StoryNode#ForEachMatchOutgoingEdges(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryNode__ForEachMatchOutgoingEdges__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.StoryNode#SingleMatchOutgoingEdges(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Single Match Outgoing Edges</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Single Match Outgoing Edges</em>' operation.
	 * @see de.mdelab.mlsdm.StoryNode#SingleMatchOutgoingEdges(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStoryNode__SingleMatchOutgoingEdges__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.StructuredNode <em>Structured Node</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Structured Node</em>'.
	 * @see de.mdelab.mlsdm.StructuredNode
	 * @generated
	 */
	EClass getStructuredNode();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.StructuredNode#InitialNodeContained(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Initial Node Contained</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Initial Node Contained</em>' operation.
	 * @see de.mdelab.mlsdm.StructuredNode#InitialNodeContained(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStructuredNode__InitialNodeContained__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.StructuredNode#FinalNodeContained(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Final Node Contained</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Final Node Contained</em>' operation.
	 * @see de.mdelab.mlsdm.StructuredNode#FinalNodeContained(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getStructuredNode__FinalNodeContained__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.Semaphore <em>Semaphore</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Semaphore</em>'.
	 * @see de.mdelab.mlsdm.Semaphore
	 * @generated
	 */
	EClass getSemaphore();

	/**
	 * Returns the meta object for the container reference '{@link de.mdelab.mlsdm.Semaphore#getActivityNodeContainer <em>Activity Node Container</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the container reference '<em>Activity Node Container</em>'.
	 * @see de.mdelab.mlsdm.Semaphore#getActivityNodeContainer()
	 * @see #getSemaphore()
	 * @generated
	 */
	EReference getSemaphore_ActivityNodeContainer();

	/**
	 * Returns the meta object for the attribute '{@link de.mdelab.mlsdm.Semaphore#getTokenCount <em>Token Count</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Token Count</em>'.
	 * @see de.mdelab.mlsdm.Semaphore#getTokenCount()
	 * @see #getSemaphore()
	 * @generated
	 */
	EAttribute getSemaphore_TokenCount();

	/**
	 * Returns the meta object for the reference list '{@link de.mdelab.mlsdm.Semaphore#getAcquireEdges <em>Acquire Edges</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Acquire Edges</em>'.
	 * @see de.mdelab.mlsdm.Semaphore#getAcquireEdges()
	 * @see #getSemaphore()
	 * @generated
	 */
	EReference getSemaphore_AcquireEdges();

	/**
	 * Returns the meta object for the reference list '{@link de.mdelab.mlsdm.Semaphore#getReleaseEdges <em>Release Edges</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Release Edges</em>'.
	 * @see de.mdelab.mlsdm.Semaphore#getReleaseEdges()
	 * @see #getSemaphore()
	 * @generated
	 */
	EReference getSemaphore_ReleaseEdges();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.Semaphore#TokenCountNotNegative(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Token Count Not Negative</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Token Count Not Negative</em>' operation.
	 * @see de.mdelab.mlsdm.Semaphore#TokenCountNotNegative(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSemaphore__TokenCountNotNegative__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.Semaphore#ReleaseEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Release Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Release Edge</em>' operation.
	 * @see de.mdelab.mlsdm.Semaphore#ReleaseEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSemaphore__ReleaseEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.Semaphore#AcquireEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Acquire Edge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Acquire Edge</em>' operation.
	 * @see de.mdelab.mlsdm.Semaphore#AcquireEdge(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSemaphore__AcquireEdge__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.SynchronizationEdge <em>Synchronization Edge</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Synchronization Edge</em>'.
	 * @see de.mdelab.mlsdm.SynchronizationEdge
	 * @generated
	 */
	EClass getSynchronizationEdge();

	/**
	 * Returns the meta object for the container reference '{@link de.mdelab.mlsdm.SynchronizationEdge#getActivityNodeContainer <em>Activity Node Container</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for the container reference '<em>Activity Node Container</em>'.
	 * @see de.mdelab.mlsdm.SynchronizationEdge#getActivityNodeContainer()
	 * @see #getSynchronizationEdge()
	 * @generated
	 */
	EReference getSynchronizationEdge_ActivityNodeContainer();

	/**
	 * Returns the meta object for the attribute '{@link de.mdelab.mlsdm.SynchronizationEdge#getWeight <em>Weight</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Weight</em>'.
	 * @see de.mdelab.mlsdm.SynchronizationEdge#getWeight()
	 * @see #getSynchronizationEdge()
	 * @generated
	 */
	EAttribute getSynchronizationEdge_Weight();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.SynchronizationEdge#WeightPositive(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Weight Positive</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Weight Positive</em>' operation.
	 * @see de.mdelab.mlsdm.SynchronizationEdge#WeightPositive(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getSynchronizationEdge__WeightPositive__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.AcquireEdge <em>Acquire Edge</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Acquire Edge</em>'.
	 * @see de.mdelab.mlsdm.AcquireEdge
	 * @generated
	 */
	EClass getAcquireEdge();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlsdm.AcquireEdge#getActivityEdge <em>Activity Edge</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Activity Edge</em>'.
	 * @see de.mdelab.mlsdm.AcquireEdge#getActivityEdge()
	 * @see #getAcquireEdge()
	 * @generated
	 */
	EReference getAcquireEdge_ActivityEdge();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlsdm.AcquireEdge#getSemaphore <em>Semaphore</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Semaphore</em>'.
	 * @see de.mdelab.mlsdm.AcquireEdge#getSemaphore()
	 * @see #getAcquireEdge()
	 * @generated
	 */
	EReference getAcquireEdge_Semaphore();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.AcquireEdge#ActivityEdgeSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge Specified</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge Specified</em>' operation.
	 * @see de.mdelab.mlsdm.AcquireEdge#ActivityEdgeSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getAcquireEdge__ActivityEdgeSpecified__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ReleaseEdge <em>Release Edge</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Release Edge</em>'.
	 * @see de.mdelab.mlsdm.ReleaseEdge
	 * @generated
	 */
	EClass getReleaseEdge();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlsdm.ReleaseEdge#getActivityEdge <em>Activity Edge</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Activity Edge</em>'.
	 * @see de.mdelab.mlsdm.ReleaseEdge#getActivityEdge()
	 * @see #getReleaseEdge()
	 * @generated
	 */
	EReference getReleaseEdge_ActivityEdge();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlsdm.ReleaseEdge#getSemaphore <em>Semaphore</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Semaphore</em>'.
	 * @see de.mdelab.mlsdm.ReleaseEdge#getSemaphore()
	 * @see #getReleaseEdge()
	 * @generated
	 */
	EReference getReleaseEdge_Semaphore();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ReleaseEdge#ActivityEdgeSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Activity Edge Specified</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Activity Edge Specified</em>' operation.
	 * @see de.mdelab.mlsdm.ReleaseEdge#ActivityEdgeSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getReleaseEdge__ActivityEdgeSpecified__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.ActivityParameter <em>Activity Parameter</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activity Parameter</em>'.
	 * @see de.mdelab.mlsdm.ActivityParameter
	 * @generated
	 */
	EClass getActivityParameter();

	/**
	 * Returns the meta object for the attribute '{@link de.mdelab.mlsdm.ActivityParameter#getDirection <em>Direction</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Direction</em>'.
	 * @see de.mdelab.mlsdm.ActivityParameter#getDirection()
	 * @see #getActivityParameter()
	 * @generated
	 */
	EAttribute getActivityParameter_Direction();

	/**
	 * Returns the meta object for the container reference '{@link de.mdelab.mlsdm.ActivityParameter#getActivity <em>Activity</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Activity</em>'.
	 * @see de.mdelab.mlsdm.ActivityParameter#getActivity()
	 * @see #getActivityParameter()
	 * @generated
	 */
	EReference getActivityParameter_Activity();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityParameter#DirectionSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Direction Specified</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Direction Specified</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityParameter#DirectionSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityParameter__DirectionSpecified__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.ActivityParameter#TypeSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Type Specified</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Type Specified</em>' operation.
	 * @see de.mdelab.mlsdm.ActivityParameter#TypeSpecified(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getActivityParameter__TypeSpecified__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlsdm.OutputParameterValue <em>Output Parameter Value</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>Output Parameter Value</em>'.
	 * @see de.mdelab.mlsdm.OutputParameterValue
	 * @generated
	 */
	EClass getOutputParameterValue();

	/**
	 * Returns the meta object for the reference '{@link de.mdelab.mlsdm.OutputParameterValue#getParameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parameter</em>'.
	 * @see de.mdelab.mlsdm.OutputParameterValue#getParameter()
	 * @see #getOutputParameterValue()
	 * @generated
	 */
	EReference getOutputParameterValue_Parameter();

	/**
	 * Returns the meta object for the containment reference '{@link de.mdelab.mlsdm.OutputParameterValue#getExpression <em>Expression</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expression</em>'.
	 * @see de.mdelab.mlsdm.OutputParameterValue#getExpression()
	 * @see #getOutputParameterValue()
	 * @generated
	 */
	EReference getOutputParameterValue_Expression();

	/**
	 * Returns the meta object for the container reference '
	 * {@link de.mdelab.mlsdm.OutputParameterValue#getActivityFinalNode
	 * <em>Activity Final Node</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for the container reference '
	 *         <em>Activity Final Node</em>'.
	 * @see de.mdelab.mlsdm.OutputParameterValue#getActivityFinalNode()
	 * @see #getOutputParameterValue()
	 * @generated
	 */
	EReference getOutputParameterValue_ActivityFinalNode();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.OutputParameterValue#ExpressionSpecfied(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Expression Specfied</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Expression Specfied</em>' operation.
	 * @see de.mdelab.mlsdm.OutputParameterValue#ExpressionSpecfied(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getOutputParameterValue__ExpressionSpecfied__DiagnosticChain_Map();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlsdm.OutputParameterValue#ParameterSpecfied(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>Parameter Specfied</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Parameter Specfied</em>' operation.
	 * @see de.mdelab.mlsdm.OutputParameterValue#ParameterSpecfied(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getOutputParameterValue__ParameterSpecfied__DiagnosticChain_Map();

	/**
	 * Returns the meta object for enum '{@link de.mdelab.mlsdm.ActivityEdgeGuardEnum <em>Activity Edge Guard Enum</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for enum '<em>Activity Edge Guard Enum</em>'.
	 * @see de.mdelab.mlsdm.ActivityEdgeGuardEnum
	 * @generated
	 */
	EEnum getActivityEdgeGuardEnum();

	/**
	 * Returns the meta object for enum '{@link de.mdelab.mlsdm.StoryNodeSemanticsEnum <em>Story Node Semantics Enum</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for enum '<em>Story Node Semantics Enum</em>'.
	 * @see de.mdelab.mlsdm.StoryNodeSemanticsEnum
	 * @generated
	 */
	EEnum getStoryNodeSemanticsEnum();

	/**
	 * Returns the meta object for enum '{@link de.mdelab.mlsdm.ActivityParameterDirectionEnum <em>Activity Parameter Direction Enum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Activity Parameter Direction Enum</em>'.
	 * @see de.mdelab.mlsdm.ActivityParameterDirectionEnum
	 * @generated
	 */
	EEnum getActivityParameterDirectionEnum();

	/**
	 * Returns the factory that creates the instances of the model. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MlsdmFactory getMlsdmFactory();

	/**
	 * <!-- begin-user-doc --> Defines literals for the meta objects that
	 * represent
	 * <ul>
	 * <li>each class,</li>
	 * <li>each feature of each class,</li>
	 * <li>each operation of each class,</li>
	 * <li>each enum,</li>
	 * <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.ActivityNodeContainerImpl <em>Activity Node Container</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.ActivityNodeContainerImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityNodeContainer()
		 * @generated
		 */
		EClass ACTIVITY_NODE_CONTAINER = eINSTANCE.getActivityNodeContainer();

		/**
		 * The meta object literal for the '<em><b>Edges</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_NODE_CONTAINER__EDGES = eINSTANCE
				.getActivityNodeContainer_Edges();

		/**
		 * The meta object literal for the '<em><b>Nodes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_NODE_CONTAINER__NODES = eINSTANCE
				.getActivityNodeContainer_Nodes();

		/**
		 * The meta object literal for the '<em><b>Semaphores</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_NODE_CONTAINER__SEMAPHORES = eINSTANCE
				.getActivityNodeContainer_Semaphores();

		/**
		 * The meta object literal for the '<em><b>Synchronization Edges</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_NODE_CONTAINER__SYNCHRONIZATION_EDGES = eINSTANCE
				.getActivityNodeContainer_SynchronizationEdges();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.ActivityImpl <em>Activity</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.ActivityImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivity()
		 * @generated
		 */
		EClass ACTIVITY = eINSTANCE.getActivity();

		/**
		 * The meta object literal for the '<em><b>Parameters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY__PARAMETERS = eINSTANCE.getActivity_Parameters();

		/**
		 * The meta object literal for the '<em><b>Parameter Distinct Names</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY___PARAMETER_DISTINCT_NAMES__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivity__ParameterDistinctNames__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>At Least One Final Node</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY___AT_LEAST_ONE_FINAL_NODE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivity__AtLeastOneFinalNode__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Name</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY___ACTIVITY_NAME__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivity__ActivityName__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>One Initial Node</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY___ONE_INITIAL_NODE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivity__OneInitialNode__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.ActivityNodeImpl <em>Activity Node</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.ActivityNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityNode()
		 * @generated
		 */
		EClass ACTIVITY_NODE = eINSTANCE.getActivityNode();

		/**
		 * The meta object literal for the '<em><b>Outgoing Edges</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_NODE__OUTGOING_EDGES = eINSTANCE
				.getActivityNode_OutgoingEdges();

		/**
		 * The meta object literal for the '<em><b>Incoming Edges</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_NODE__INCOMING_EDGES = eINSTANCE
				.getActivityNode_IncomingEdges();

		/**
		 * The meta object literal for the '<em><b>Activity Node Container</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER = eINSTANCE
				.getActivityNode_ActivityNodeContainer();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.ActivityEdgeImpl <em>Activity Edge</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.ActivityEdgeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityEdge()
		 * @generated
		 */
		EClass ACTIVITY_EDGE = eINSTANCE.getActivityEdge();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_EDGE__SOURCE = eINSTANCE.getActivityEdge_Source();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_EDGE__TARGET = eINSTANCE.getActivityEdge_Target();

		/**
		 * The meta object literal for the '<em><b>Activity Node Container</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_EDGE__ACTIVITY_NODE_CONTAINER = eINSTANCE
				.getActivityEdge_ActivityNodeContainer();

		/**
		 * The meta object literal for the '<em><b>Guard Type</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ACTIVITY_EDGE__GUARD_TYPE = eINSTANCE
				.getActivityEdge_GuardType();

		/**
		 * The meta object literal for the '<em><b>Guard Expression</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_EDGE__GUARD_EXPRESSION = eINSTANCE
				.getActivityEdge_GuardExpression();

		/**
		 * The meta object literal for the '<em><b>Acquire Edges</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_EDGE__ACQUIRE_EDGES = eINSTANCE
				.getActivityEdge_AcquireEdges();

		/**
		 * The meta object literal for the '<em><b>Release Edges</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_EDGE__RELEASE_EDGES = eINSTANCE
				.getActivityEdge_ReleaseEdges();

		/**
		 * The meta object literal for the '<em><b>Assertion Expressions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_EDGE__ASSERTION_EXPRESSIONS = eINSTANCE
				.getActivityEdge_AssertionExpressions();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Boolean Guard</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_BOOLEAN_GUARD__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeBooleanGuard__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Success Guard</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_SUCCESS_GUARD__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeSuccessGuard__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Guard Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_TYPE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeGuardType__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Edge For Each Guard</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_FOR_EACH_GUARD__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeForEachGuard__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Source</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_SOURCE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeSource__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Else Guard</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_ELSE_GUARD__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeElseGuard__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Target</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_TARGET__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeTarget__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Failure Guard</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_FAILURE_GUARD__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeFailureGuard__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Guard Expression</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeGuardExpression__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Edge No Guard Expression</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_NO_GUARD_EXPRESSION__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeNoGuardExpression__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Activity Edge End Guard</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_EDGE___ACTIVITY_EDGE_END_GUARD__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityEdge__ActivityEdgeEndGuard__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.InitialNodeImpl <em>Initial Node</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.InitialNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getInitialNode()
		 * @generated
		 */
		EClass INITIAL_NODE = eINSTANCE.getInitialNode();

		/**
		 * The meta object literal for the '<em><b>Initial Node Incoming Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation INITIAL_NODE___INITIAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getInitialNode__InitialNodeIncomingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Initial Node Outgoing Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation INITIAL_NODE___INITIAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getInitialNode__InitialNodeOutgoingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.FlowFinalNodeImpl <em>Flow Final Node</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.FlowFinalNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getFlowFinalNode()
		 * @generated
		 */
		EClass FLOW_FINAL_NODE = eINSTANCE.getFlowFinalNode();

		/**
		 * The meta object literal for the '<em><b>Flow Final Node Incoming Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation FLOW_FINAL_NODE___FLOW_FINAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getFlowFinalNode__FlowFinalNodeIncomingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Flow Final Node Outgoing Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation FLOW_FINAL_NODE___FLOW_FINAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getFlowFinalNode__FlowFinalNodeOutgoingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.ActivityFinalNodeImpl <em>Activity Final Node</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.ActivityFinalNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityFinalNode()
		 * @generated
		 */
		EClass ACTIVITY_FINAL_NODE = eINSTANCE.getActivityFinalNode();

		/**
		 * The meta object literal for the '<em><b>Output Parameter Values</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES = eINSTANCE
				.getActivityFinalNode_OutputParameterValues();

		/**
		 * The meta object literal for the '<em><b>Activity</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_FINAL_NODE__ACTIVITY = eINSTANCE
				.getActivityFinalNode_Activity();

		/**
		 * The meta object literal for the '<em><b>Incoming Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_FINAL_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityFinalNode__IncomingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>No Output Parameter Value</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_FINAL_NODE___NO_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityFinalNode__NoOutputParameterValue__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Outgoing Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_FINAL_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityFinalNode__OutgoingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>One Output Parameter Value</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_FINAL_NODE___ONE_OUTPUT_PARAMETER_VALUE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityFinalNode__OneOutputParameterValue__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.ExpressionActivityNodeImpl <em>Expression Activity Node</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.ExpressionActivityNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getExpressionActivityNode()
		 * @generated
		 */
		EClass EXPRESSION_ACTIVITY_NODE = eINSTANCE.getExpressionActivityNode();

		/**
		 * The meta object literal for the '<em><b>Expressions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference EXPRESSION_ACTIVITY_NODE__EXPRESSIONS = eINSTANCE
				.getExpressionActivityNode_Expressions();

		/**
		 * The meta object literal for the '<em><b>One Outgoing Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation EXPRESSION_ACTIVITY_NODE___ONE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getExpressionActivityNode__OneOutgoingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>One Incoming Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation EXPRESSION_ACTIVITY_NODE___ONE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getExpressionActivityNode__OneIncomingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Expression Specified</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation EXPRESSION_ACTIVITY_NODE___EXPRESSION_SPECIFIED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getExpressionActivityNode__ExpressionSpecified__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.DecisionMergeNodeImpl <em>Decision Merge Node</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.DecisionMergeNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getDecisionMergeNode()
		 * @generated
		 */
		EClass DECISION_MERGE_NODE = eINSTANCE.getDecisionMergeNode();

		/**
		 * The meta object literal for the '<em><b>Incoming Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation DECISION_MERGE_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getDecisionMergeNode__IncomingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Multiple Edge Guards</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation DECISION_MERGE_NODE___MULTIPLE_EDGE_GUARDS__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getDecisionMergeNode__MultipleEdgeGuards__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Single Edge Guard</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation DECISION_MERGE_NODE___SINGLE_EDGE_GUARD__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getDecisionMergeNode__SingleEdgeGuard__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Outgoing Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation DECISION_MERGE_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getDecisionMergeNode__OutgoingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.ForkJoinNodeImpl <em>Fork Join Node</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.ForkJoinNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getForkJoinNode()
		 * @generated
		 */
		EClass FORK_JOIN_NODE = eINSTANCE.getForkJoinNode();

		/**
		 * The meta object literal for the '<em><b>Incoming Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation FORK_JOIN_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getForkJoinNode__IncomingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Outgoing Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation FORK_JOIN_NODE___OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getForkJoinNode__OutgoingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.StoryNodeImpl <em>Story Node</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.StoryNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStoryNode()
		 * @generated
		 */
		EClass STORY_NODE = eINSTANCE.getStoryNode();

		/**
		 * The meta object literal for the '<em><b>Story Pattern</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference STORY_NODE__STORY_PATTERN = eINSTANCE
				.getStoryNode_StoryPattern();

		/**
		 * The meta object literal for the '<em><b>Semantics</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STORY_NODE__SEMANTICS = eINSTANCE.getStoryNode_Semantics();

		/**
		 * The meta object literal for the '<em><b>Incoming Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryNode__IncomingEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>For Each Loop Body</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_NODE___FOR_EACH_LOOP_BODY__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryNode__ForEachLoopBody__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Story Pattern Specified</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_NODE___STORY_PATTERN_SPECIFIED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryNode__StoryPatternSpecified__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Semantics Specified</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_NODE___SEMANTICS_SPECIFIED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryNode__SemanticsSpecified__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>For Each Match Outgoing Edges</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_NODE___FOR_EACH_MATCH_OUTGOING_EDGES__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryNode__ForEachMatchOutgoingEdges__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Single Match Outgoing Edges</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STORY_NODE___SINGLE_MATCH_OUTGOING_EDGES__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStoryNode__SingleMatchOutgoingEdges__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.StructuredNodeImpl <em>Structured Node</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.StructuredNodeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStructuredNode()
		 * @generated
		 */
		EClass STRUCTURED_NODE = eINSTANCE.getStructuredNode();

		/**
		 * The meta object literal for the '<em><b>Initial Node Contained</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STRUCTURED_NODE___INITIAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStructuredNode__InitialNodeContained__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Final Node Contained</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation STRUCTURED_NODE___FINAL_NODE_CONTAINED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getStructuredNode__FinalNodeContained__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.SemaphoreImpl <em>Semaphore</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.SemaphoreImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getSemaphore()
		 * @generated
		 */
		EClass SEMAPHORE = eINSTANCE.getSemaphore();

		/**
		 * The meta object literal for the '<em><b>Activity Node Container</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEMAPHORE__ACTIVITY_NODE_CONTAINER = eINSTANCE
				.getSemaphore_ActivityNodeContainer();

		/**
		 * The meta object literal for the '<em><b>Token Count</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SEMAPHORE__TOKEN_COUNT = eINSTANCE.getSemaphore_TokenCount();

		/**
		 * The meta object literal for the '<em><b>Acquire Edges</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEMAPHORE__ACQUIRE_EDGES = eINSTANCE
				.getSemaphore_AcquireEdges();

		/**
		 * The meta object literal for the '<em><b>Release Edges</b></em>' reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEMAPHORE__RELEASE_EDGES = eINSTANCE
				.getSemaphore_ReleaseEdges();

		/**
		 * The meta object literal for the '<em><b>Token Count Not Negative</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation SEMAPHORE___TOKEN_COUNT_NOT_NEGATIVE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getSemaphore__TokenCountNotNegative__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Release Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation SEMAPHORE___RELEASE_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getSemaphore__ReleaseEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Acquire Edge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation SEMAPHORE___ACQUIRE_EDGE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getSemaphore__AcquireEdge__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.SynchronizationEdgeImpl <em>Synchronization Edge</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.SynchronizationEdgeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getSynchronizationEdge()
		 * @generated
		 */
		EClass SYNCHRONIZATION_EDGE = eINSTANCE.getSynchronizationEdge();

		/**
		 * The meta object literal for the '<em><b>Activity Node Container</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference SYNCHRONIZATION_EDGE__ACTIVITY_NODE_CONTAINER = eINSTANCE
				.getSynchronizationEdge_ActivityNodeContainer();

		/**
		 * The meta object literal for the '<em><b>Weight</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SYNCHRONIZATION_EDGE__WEIGHT = eINSTANCE
				.getSynchronizationEdge_Weight();

		/**
		 * The meta object literal for the '<em><b>Weight Positive</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation SYNCHRONIZATION_EDGE___WEIGHT_POSITIVE__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getSynchronizationEdge__WeightPositive__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.AcquireEdgeImpl <em>Acquire Edge</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.AcquireEdgeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getAcquireEdge()
		 * @generated
		 */
		EClass ACQUIRE_EDGE = eINSTANCE.getAcquireEdge();

		/**
		 * The meta object literal for the '<em><b>Activity Edge</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACQUIRE_EDGE__ACTIVITY_EDGE = eINSTANCE
				.getAcquireEdge_ActivityEdge();

		/**
		 * The meta object literal for the '<em><b>Semaphore</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACQUIRE_EDGE__SEMAPHORE = eINSTANCE
				.getAcquireEdge_Semaphore();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Specified</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACQUIRE_EDGE___ACTIVITY_EDGE_SPECIFIED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getAcquireEdge__ActivityEdgeSpecified__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.ReleaseEdgeImpl <em>Release Edge</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.ReleaseEdgeImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getReleaseEdge()
		 * @generated
		 */
		EClass RELEASE_EDGE = eINSTANCE.getReleaseEdge();

		/**
		 * The meta object literal for the '<em><b>Activity Edge</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELEASE_EDGE__ACTIVITY_EDGE = eINSTANCE
				.getReleaseEdge_ActivityEdge();

		/**
		 * The meta object literal for the '<em><b>Semaphore</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELEASE_EDGE__SEMAPHORE = eINSTANCE
				.getReleaseEdge_Semaphore();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Specified</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RELEASE_EDGE___ACTIVITY_EDGE_SPECIFIED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getReleaseEdge__ActivityEdgeSpecified__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.ActivityParameterImpl <em>Activity Parameter</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.ActivityParameterImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityParameter()
		 * @generated
		 */
		EClass ACTIVITY_PARAMETER = eINSTANCE.getActivityParameter();

		/**
		 * The meta object literal for the '<em><b>Direction</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ACTIVITY_PARAMETER__DIRECTION = eINSTANCE
				.getActivityParameter_Direction();

		/**
		 * The meta object literal for the '<em><b>Activity</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVITY_PARAMETER__ACTIVITY = eINSTANCE
				.getActivityParameter_Activity();

		/**
		 * The meta object literal for the '<em><b>Direction Specified</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_PARAMETER___DIRECTION_SPECIFIED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityParameter__DirectionSpecified__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Type Specified</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ACTIVITY_PARAMETER___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getActivityParameter__TypeSpecified__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.impl.OutputParameterValueImpl <em>Output Parameter Value</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlsdm.impl.OutputParameterValueImpl
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getOutputParameterValue()
		 * @generated
		 */
		EClass OUTPUT_PARAMETER_VALUE = eINSTANCE.getOutputParameterValue();

		/**
		 * The meta object literal for the '<em><b>Parameter</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference OUTPUT_PARAMETER_VALUE__PARAMETER = eINSTANCE
				.getOutputParameterValue_Parameter();

		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' containment reference feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference OUTPUT_PARAMETER_VALUE__EXPRESSION = eINSTANCE
				.getOutputParameterValue_Expression();

		/**
		 * The meta object literal for the '<em><b>Activity Final Node</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE = eINSTANCE
				.getOutputParameterValue_ActivityFinalNode();

		/**
		 * The meta object literal for the '<em><b>Expression Specfied</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation OUTPUT_PARAMETER_VALUE___EXPRESSION_SPECFIED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getOutputParameterValue__ExpressionSpecfied__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '<em><b>Parameter Specfied</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation OUTPUT_PARAMETER_VALUE___PARAMETER_SPECFIED__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getOutputParameterValue__ParameterSpecfied__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.ActivityEdgeGuardEnum <em>Activity Edge Guard Enum</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.ActivityEdgeGuardEnum
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityEdgeGuardEnum()
		 * @generated
		 */
		EEnum ACTIVITY_EDGE_GUARD_ENUM = eINSTANCE.getActivityEdgeGuardEnum();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlsdm.StoryNodeSemanticsEnum <em>Story Node Semantics Enum</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.mdelab.mlsdm.StoryNodeSemanticsEnum
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getStoryNodeSemanticsEnum()
		 * @generated
		 */
		EEnum STORY_NODE_SEMANTICS_ENUM = eINSTANCE.getStoryNodeSemanticsEnum();

		/**
		 * The meta object literal for the '
		 * {@link de.mdelab.mlsdm.ActivityParameterDirectionEnum
		 * <em>Activity Parameter Direction Enum</em>}' enum. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see de.mdelab.mlsdm.ActivityParameterDirectionEnum
		 * @see de.mdelab.mlsdm.impl.MlsdmPackageImpl#getActivityParameterDirectionEnum()
		 * @generated
		 */
		EEnum ACTIVITY_PARAMETER_DIRECTION_ENUM = eINSTANCE
				.getActivityParameterDirectionEnum();

	}

} // MlsdmPackage
