/**
 */
package de.mdelab.mlsdm;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlexpressions.MLExpression;
import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Output Parameter Value</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Specifies the return value of an ActivityParameter using an expression.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.OutputParameterValue#getParameter <em>Parameter</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.OutputParameterValue#getExpression <em>Expression</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.OutputParameterValue#getActivityFinalNode <em>Activity Final Node</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlsdm.MlsdmPackage#getOutputParameterValue()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='ParameterSpecfied'"
 * @generated
 */
public interface OutputParameterValue
		extends
			MLElementWithUUID,
			MLAnnotatedElement {
	/**
	 * Returns the value of the '<em><b>Parameter</b></em>' reference. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameter</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Parameter</em>' reference.
	 * @see #setParameter(ActivityParameter)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getOutputParameterValue_Parameter()
	 * @model required="true"
	 * @generated
	 */
	ActivityParameter getParameter();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlsdm.OutputParameterValue#getParameter
	 * <em>Parameter</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Parameter</em>' reference.
	 * @see #getParameter()
	 * @generated
	 */
	void setParameter(ActivityParameter value);

	/**
	 * Returns the value of the '<em><b>Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Expression</em>' containment reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Expression</em>' containment reference.
	 * @see #setExpression(MLExpression)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getOutputParameterValue_Expression()
	 * @model containment="true" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!OutputParameterValue!expression'"
	 * @generated
	 */
	MLExpression getExpression();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.OutputParameterValue#getExpression <em>Expression</em>}' containment reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Expression</em>' containment reference.
	 * @see #getExpression()
	 * @generated
	 */
	void setExpression(MLExpression value);

	/**
	 * Returns the value of the '<em><b>Activity Final Node</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlsdm.ActivityFinalNode#getOutputParameterValues <em>Output Parameter Values</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activity Final Node</em>' container reference
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Activity Final Node</em>' container reference.
	 * @see #setActivityFinalNode(ActivityFinalNode)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getOutputParameterValue_ActivityFinalNode()
	 * @see de.mdelab.mlsdm.ActivityFinalNode#getOutputParameterValues
	 * @model opposite="outputParameterValues" resolveProxies="false" required="true" transient="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!OutputParameterValue!activityFinalNode'"
	 * @generated
	 */
	ActivityFinalNode getActivityFinalNode();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.OutputParameterValue#getActivityFinalNode <em>Activity Final Node</em>}' container reference.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Activity Final Node</em>' container reference.
	 * @see #getActivityFinalNode()
	 * @generated
	 */
	void setActivityFinalNode(ActivityFinalNode value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='/**\n *\n * inv ExpressionSpecfied:\n *   let\n *     severity : Integer[1] = \'OutputParameterValue::ExpressionSpecfied\'.getSeverity()\n *   in\n *     if severity &lt;= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.expression &lt;&gt; null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Expression of output parameter value assignment \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'OutputParameterValue::ExpressionSpecfied\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n \052/\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%&gt;.getExecutor(this);\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.STR_OutputParameterValue_c_c_ExpressionSpecfied);\nfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_0;\nif (le) {\n\tsymbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.STR_OutputParameterValue_c_c_ExpressionSpecfied, this, (Object)null, diagnostics, context, (Object)null, severity_0, &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;'"
	 * @generated
	 */
	boolean ExpressionSpecfied(DiagnosticChain diagnostics,
			Map<Object, Object> context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='/**\n *\n * inv ParameterSpecfied:\n *   let\n *     severity : Integer[1] = \'OutputParameterValue::ParameterSpecfied\'.getSeverity()\n *   in\n *     if severity &lt;= 0\n *     then true\n *     else\n *       let\n *         result : OclAny[1] = let\n *           status : Boolean[?] = if self.parameter &lt;&gt; null\n *           then true\n *           else null\n *           endif\n *         in\n *           if status = true\n *           then true\n *           else\n *             Tuple{message = \'Parameter of output parameter value assignment \' +\n *               self.toString() + \' must be specified.\', status = status\n *             }\n *           endif\n *       in\n *         \'OutputParameterValue::ParameterSpecfied\'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n *     endif\n \052/\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal%&gt;.getExecutor(this);\nfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.STR_OutputParameterValue_c_c_ParameterSpecfied);\nfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_0;\nif (le) {\n\tsymbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n}\nelse {\n\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.STR_OutputParameterValue_c_c_ParameterSpecfied, this, (Object)null, diagnostics, context, (Object)null, severity_0, &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\tsymbol_0 = logDiagnostic;\n}\nreturn Boolean.TRUE == symbol_0;'"
	 * @generated
	 */
	boolean ParameterSpecfied(DiagnosticChain diagnostics,
			Map<Object, Object> context);

} // OutputParameterValue
