package de.mdelab.mlsdm.diagram.custom.edit.parts;

import org.eclipse.draw2d.PositionConstants;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.expressiondialogs.Utility;
import de.mdelab.mlcallactions.CallAction;
import de.mdelab.mlcallactions.CallActionParameter;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityEdgeGuardEnum;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel4EditPart;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.IMLExpressionEditPart;

public class CustomActivityEdgeGuardConstraintLabelEditPart extends WrappingLabel4EditPart implements IMLExpressionEditPart {

	public CustomActivityEdgeGuardConstraintLabelEditPart(View view) {
		super(view);
	}

	/*
	 * should be similar to addNotationalListeners of:
	 * 
	 * CustomActivityEdgeGuardConstraintLabelEditPart
	 * CustomActivityFinalNodeReturnValueLabelEditPart
	 * CustomAttributeAssignmentEditPart CustomCallActionExpressionEditPart
	 * CustomCallActionExpression2EditPart CustomCallActionExpression3EditPart
	 * CustomStoryPatternExpressionLinkFeatureNameLabelEditPart
	 * CustomStoryPatternObjectClassifierLabelEditPart
	 */
	@Override
	protected void addNotationalListeners()
	{
		super.addNotationalListeners();
		//TODO:
		/*if (((View) getModel()).getElement() instanceof ActivityEdge){
			MLExpression expr = ((ActivityEdge) ((View) getModel()).getElement()).getGuardExpression();
			//	JOptionPane.showInputDialog(expr + "ccd");
			EStructuralFeature feat = (EStructuralFeature) ((ActivityEdge) ((View) getModel()).getElement()).getGuardExpression();
			String s = ((ActivityEdge) ((View) getModel()).getElement()).getUuid();
		
			//this.addListenerFilter(feat.eClass().getName(), this, feat);
			this.addListenerFilter(s, this, feat);
		}*/
		MLExpression expr = (MLExpression) ((ActivityEdge) ((View) getModel()).getElement()).getGuardExpression();
		String text ="";
		if (expr != null)
		{
			try{
				ComposedAdapterFactory factory = new ComposedAdapterFactory(EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());
				text = ((IItemLabelProvider) factory.adapt(expr, IItemLabelProvider.class)).getText(expr);
			}
			catch (Exception e){
				e.printStackTrace();
			}
			//JOptionPane.showInputDialog("njhkj");
			this.addListenerFilter(expr.eClass().getName() + text, this, expr);
		}
/*
			if (expr instanceof CallActionExpression)
			{
				TreeIterator<EObject> it = ((CallActionExpression) expr).eAllContents();
				for (EObject eObj; it.hasNext();)
				{
					eObj = it.next();
					this.addListenerFilter(Utility.getFilterId((MLNamedElement) eObj), this, eObj);
				}
			}*/
		//}
	}

	/*
	 * should be similar to handleNotificationEvent of:
	 * 
	 * CustomActivityEdgeGuardConstraintLabelEditPart
	 * CustomActivityFinalNodeReturnValueLabelEditPart
	 * CustomAttributeAssignmentEditPart CustomCallActionExpressionEditPart
	 * CustomCallActionExpression2EditPart CustomCallActionExpression3EditPart
	 * CustomStoryPatternExpressionLinkFeatureNameLabelEditPart
	 * CustomStoryPatternObjectClassifierLabelEditPart
	 */
	@Override
	protected void handleNotificationEvent(Notification event)
	{
		Object notifier = event.getNotifier();
		Object newValue = event.getNewValue();
		Object oldValue = event.getOldValue();
		int eventType = event.getEventType();

		if ((eventType == Notification.SET || eventType == Notification.ADD)
				&& (newValue instanceof CallAction || newValue instanceof MLExpression || newValue instanceof CallActionParameter))
		{
			// DB: Bug #1802
			this.addListenerFilter(Utility.getFilterId((EObject) newValue), this, (EObject) newValue);
			updateFigure();
		}
		else if (eventType == Notification.REMOVE
				&& (oldValue instanceof CallAction || oldValue instanceof MLExpression || oldValue instanceof CallActionParameter))
		{
			// DB: Bug #1802
			this.removeListenerFilter(Utility.getFilterId((EObject) oldValue));
			updateFigure();
		}
		else if (notifier instanceof ActivityEdge || notifier instanceof CallAction || notifier instanceof MLExpression
				|| notifier instanceof CallActionParameter)
		{
			updateFigure();
		}

		super.handleNotificationEvent(event);
	}

	protected static String format(String text)
	{
		return "[ " + text + " ]";
	}

	public void updateFigure()
	{
		((WrappingLabel) getFigure()).setTextWrap(true);
		((WrappingLabel) getFigure()).setTextJustification(PositionConstants.CENTER);

		ActivityEdge edge = (ActivityEdge) ((View) getModel()).getElement();

		String text = "";
		if (edge.getGuardExpression() != null)
		{
			text = format(edge.getGuardExpression().toString());
			try{
				ComposedAdapterFactory factory = new ComposedAdapterFactory(EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());
				if (edge != null & edge.getGuardExpression() != null){
					text = ((IItemLabelProvider) factory.adapt(edge.getGuardExpression(), IItemLabelProvider.class)).getText(edge.getGuardExpression());
				}
				else
				{
					text = "";
				}
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
		else if (edge.getGuardType() != ActivityEdgeGuardEnum.NONE)
		{
			text = format(Utility.GuardEnum2String(edge.getGuardType()));
		}
			
		setLabelText(text);
	}

	protected void refreshVisuals()
	{
		super.refreshVisuals();
		updateFigure();
	}

	@Override
	public MLExpression getMLExpression() {
		return ( (ActivityEdge) ( (View) getModel() ).getElement() ).getGuardExpression();
	}
}
