package de.mdelab.mlsdm.diagram.custom.edit.parts;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel9EditPart;
import de.mdelab.mlstorypatterns.ExpressionLink;

public class CustomStoryExpressionLinkLabelEditPart extends WrappingLabel9EditPart
{

	public CustomStoryExpressionLinkLabelEditPart(View view)
	{
		super(view); 
	}
//	@Override
//	protected void addNotationalListeners()
//	{
//		super.addNotationalListeners();
//		//MLExpression expr = ((ExpressionLink) ((View) getModel()).getElement()).getExpression();
//		//this.addListenerFilter(expr.eClass().toString(), this, expr);
//	}
	@Override
	protected void handleNotificationEvent(Notification event)
	{
		if (event.getNotifier() instanceof ExpressionLink)
		{
			update();
		}

		super.handleNotificationEvent(event);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		update();
	}

	protected void update()
	{
		ExpressionLink spo = ((ExpressionLink) ((View) getModel()).getElement());

		String text = "[null]";
		MLExpression expr = spo.getExpression();
		if (expr!=null){
			try{
			ComposedAdapterFactory factory = new ComposedAdapterFactory(EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());
			text = ((IItemLabelProvider) factory.adapt(expr, IItemLabelProvider.class)).getText(expr);
			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
		setLabelText(text);
	}

}
