package de.mdelab.mlsdm.diagram.custom.edit.parts;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.expressiondialogs.Utility;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel6EditPart;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternObject;

public class CustomStoryPatternObjectModifierLabelEditPart extends WrappingLabel6EditPart
{

	public CustomStoryPatternObjectModifierLabelEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void handleNotificationEvent(Notification event)
	{
		if (event.getNotifier() instanceof StoryPatternObject)
		{
			adjustColorAndModifierLabel();
		}

		super.handleNotificationEvent(event);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		adjustColorAndModifierLabel();
	}

	protected void adjustColorAndModifierLabel()
	{
		Utility.adaptColor(getFigure(), ((StoryPatternElement) ((View) this.getModel()).getElement()).getModifier());
		StoryPatternObject spo = ((StoryPatternObject) ((View) getModel()).getElement());

		String text = "";
		if (spo.getModifier() != ModifierEnum.NONE)
		{
			text = "<< " + spo.getModifier()+ " >> ";
		}
		else
		{
			text = "";
		}
		setLabelText(text);
	}

}
