package de.mdelab.mlsdm.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.GridData;
import org.eclipse.draw2d.GridLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.core.edithelpers.CreateElementRequestAdapter;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewAndElementRequest;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.edit.policies.reparent.CreationEditPolicyWithCustomReparent;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import de.mdelab.mlsdm.diagram.edit.policies.ExpressionActivityNode2ItemSemanticEditPolicy;
import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;
import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;

/**
 * @generated
 */
public class ExpressionActivityNode2EditPart extends ShapeNodeEditPart
{

	/**
	 * @generated
	 */
	public static final int	VISUAL_ID	= 3007;

	/**
	 * @generated
	 */
	protected IFigure		contentPane;

	/**
	 * @generated
	 */
	protected IFigure		primaryShape;

	/**
	 * @generated
	 */
	public ExpressionActivityNode2EditPart(View view)
	{
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies()
	{
		installEditPolicy(EditPolicyRoles.CREATION_ROLE, new CreationEditPolicyWithCustomReparent(MlsdmVisualIDRegistry.TYPED_INSTANCE));
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new ExpressionActivityNode2ItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy()
	{
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy()
		{

			protected EditPolicy createChildEditPolicy(EditPart child)
			{
				EditPolicy result = child.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null)
				{
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request)
			{
				return null;
			}

			protected Command getCreateCommand(CreateRequest request)
			{
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape()
	{
		return primaryShape = new ExpressionActivityNodeFigureDescriptor();
	}

	/**
	 * @generated
	 */
	public ExpressionActivityNodeFigureDescriptor getPrimaryShape()
	{
		return (ExpressionActivityNodeFigureDescriptor) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart)
	{
		if (childEditPart instanceof ExpressionActivityNodeName2EditPart)
		{
			((ExpressionActivityNodeName2EditPart) childEditPart).setLabel(getPrimaryShape()
					.getFigureExpressionActivityNodeFigureNameLabel());
			return true;
		}
		if (childEditPart instanceof ExpressionActivityNodeExpressionFigureCompartment2EditPart)
		{
			IFigure pane = getPrimaryShape().getFigureExpressionActivityNodeFigureRectangleBody();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((ExpressionActivityNodeExpressionFigureCompartment2EditPart) childEditPart).getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart)
	{
		if (childEditPart instanceof ExpressionActivityNodeName2EditPart)
		{
			return true;
		}
		if (childEditPart instanceof ExpressionActivityNodeExpressionFigureCompartment2EditPart)
		{
			IFigure pane = getPrimaryShape().getFigureExpressionActivityNodeFigureRectangleBody();
			pane.remove(((ExpressionActivityNodeExpressionFigureCompartment2EditPart) childEditPart).getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index)
	{
		if (addFixedChild(childEditPart))
		{
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart)
	{
		if (removeFixedChild(childEditPart))
		{
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart)
	{
		if (editPart instanceof ExpressionActivityNodeExpressionFigureCompartment2EditPart)
		{
			return getPrimaryShape().getFigureExpressionActivityNodeFigureRectangleBody();
		}
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate()
	{
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure()
	{
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape)
	{
		if (nodeShape.getLayoutManager() == null)
		{
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane()
	{
		if (contentPane != null)
		{
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color)
	{
		if (primaryShape != null)
		{
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color)
	{
		if (primaryShape != null)
		{
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width)
	{
		if (primaryShape instanceof Shape)
		{
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style)
	{
		if (primaryShape instanceof Shape)
		{
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart()
	{
		return getChildBySemanticHint(MlsdmVisualIDRegistry.getType(ExpressionActivityNodeName2EditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(MlsdmElementTypes.ActivityEdge_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(IGraphicalEditPart targetEditPart)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof ActivityFinalNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof DecisionMergeNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ExpressionActivityNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof FlowFinalNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ForkJoinNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof InitialNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StoryNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StructuredNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof DecisionMergeNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof FlowFinalNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ForkJoinNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof InitialNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StoryNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StructuredNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ActivityFinalNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == MlsdmElementTypes.ActivityEdge_4001)
		{
			types.add(MlsdmElementTypes.ActivityFinalNode_2002);
			types.add(MlsdmElementTypes.DecisionMergeNode_2006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_2001);
			types.add(MlsdmElementTypes.FlowFinalNode_2007);
			types.add(MlsdmElementTypes.ForkJoinNode_2003);
			types.add(MlsdmElementTypes.InitialNode_2004);
			types.add(MlsdmElementTypes.StoryNode_2008);
			types.add(MlsdmElementTypes.StructuredNode_2009);
			types.add(MlsdmElementTypes.DecisionMergeNode_3006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
			types.add(MlsdmElementTypes.FlowFinalNode_3008);
			types.add(MlsdmElementTypes.ForkJoinNode_3009);
			types.add(MlsdmElementTypes.InitialNode_3010);
			types.add(MlsdmElementTypes.StoryNode_3011);
			types.add(MlsdmElementTypes.StructuredNode_3018);
			types.add(MlsdmElementTypes.ActivityFinalNode_3019);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(MlsdmElementTypes.ActivityEdge_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == MlsdmElementTypes.ActivityEdge_4001)
		{
			types.add(MlsdmElementTypes.ActivityFinalNode_2002);
			types.add(MlsdmElementTypes.DecisionMergeNode_2006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_2001);
			types.add(MlsdmElementTypes.FlowFinalNode_2007);
			types.add(MlsdmElementTypes.ForkJoinNode_2003);
			types.add(MlsdmElementTypes.InitialNode_2004);
			types.add(MlsdmElementTypes.StoryNode_2008);
			types.add(MlsdmElementTypes.StructuredNode_2009);
			types.add(MlsdmElementTypes.DecisionMergeNode_3006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
			types.add(MlsdmElementTypes.FlowFinalNode_3008);
			types.add(MlsdmElementTypes.ForkJoinNode_3009);
			types.add(MlsdmElementTypes.InitialNode_3010);
			types.add(MlsdmElementTypes.StoryNode_3011);
			types.add(MlsdmElementTypes.StructuredNode_3018);
			types.add(MlsdmElementTypes.ActivityFinalNode_3019);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public EditPart getTargetEditPart(Request request)
	{
		if (request instanceof CreateViewAndElementRequest)
		{
			CreateElementRequestAdapter adapter = ((CreateViewAndElementRequest) request).getViewAndElementDescriptor()
					.getCreateElementRequestAdapter();
			IElementType type = (IElementType) adapter.getAdapter(IElementType.class);
			if (type == MlsdmElementTypes.MLStringExpression_3001)
			{
				return getChildBySemanticHint(MlsdmVisualIDRegistry
						.getType(ExpressionActivityNodeExpressionFigureCompartment2EditPart.VISUAL_ID));
			}
			if (type == MlsdmElementTypes.CallActionExpression_3013)
			{
				return getChildBySemanticHint(MlsdmVisualIDRegistry
						.getType(ExpressionActivityNodeExpressionFigureCompartment2EditPart.VISUAL_ID));
			}
		}
		return super.getTargetEditPart(request);
	}

	/**
	 * @generated
	 */
	public class ExpressionActivityNodeFigureDescriptor extends RectangleFigure
	{

		/**
		 * @generated
		 */
		private WrappingLabel	fFigureExpressionActivityNodeFigureNameLabel;
		/**
		 * @generated
		 */
		private RectangleFigure	fFigureExpressionActivityNodeFigureRectangleBody;

		/**
		 * @generated
		 */
		public ExpressionActivityNodeFigureDescriptor()
		{

			BorderLayout layoutThis = new BorderLayout();
			this.setLayoutManager(layoutThis);

			this.setForegroundColor(ColorConstants.black);
			this.setBackgroundColor(THIS_BACK);
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents()
		{

			RectangleFigure expressionActivityNodeFigureRectangleTitle0 = new RectangleFigure();

			expressionActivityNodeFigureRectangleTitle0.setPreferredSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(30)));

			this.add(expressionActivityNodeFigureRectangleTitle0, BorderLayout.TOP);

			GridLayout layoutExpressionActivityNodeFigureRectangleTitle0 = new GridLayout();
			layoutExpressionActivityNodeFigureRectangleTitle0.numColumns = 1;
			layoutExpressionActivityNodeFigureRectangleTitle0.makeColumnsEqualWidth = true;
			expressionActivityNodeFigureRectangleTitle0.setLayoutManager(layoutExpressionActivityNodeFigureRectangleTitle0);

			fFigureExpressionActivityNodeFigureNameLabel = new WrappingLabel();

			fFigureExpressionActivityNodeFigureNameLabel.setText("");

			fFigureExpressionActivityNodeFigureNameLabel.setFont(FFIGUREEXPRESSIONACTIVITYNODEFIGURENAMELABEL_FONT);

			GridData constraintFFigureExpressionActivityNodeFigureNameLabel = new GridData();
			constraintFFigureExpressionActivityNodeFigureNameLabel.verticalAlignment = GridData.CENTER;
			constraintFFigureExpressionActivityNodeFigureNameLabel.horizontalAlignment = GridData.CENTER;
			constraintFFigureExpressionActivityNodeFigureNameLabel.horizontalIndent = 0;
			constraintFFigureExpressionActivityNodeFigureNameLabel.horizontalSpan = 1;
			constraintFFigureExpressionActivityNodeFigureNameLabel.verticalSpan = 1;
			constraintFFigureExpressionActivityNodeFigureNameLabel.grabExcessHorizontalSpace = true;
			constraintFFigureExpressionActivityNodeFigureNameLabel.grabExcessVerticalSpace = false;
			expressionActivityNodeFigureRectangleTitle0.add(fFigureExpressionActivityNodeFigureNameLabel,
					constraintFFigureExpressionActivityNodeFigureNameLabel);

			fFigureExpressionActivityNodeFigureRectangleBody = new RectangleFigure();

			fFigureExpressionActivityNodeFigureRectangleBody.setPreferredSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(
					40)));

			this.add(fFigureExpressionActivityNodeFigureRectangleBody, BorderLayout.CENTER);

			FlowLayout layoutFFigureExpressionActivityNodeFigureRectangleBody = new FlowLayout();
			layoutFFigureExpressionActivityNodeFigureRectangleBody.setStretchMinorAxis(false);
			layoutFFigureExpressionActivityNodeFigureRectangleBody.setMinorAlignment(FlowLayout.ALIGN_CENTER);

			layoutFFigureExpressionActivityNodeFigureRectangleBody.setMajorAlignment(FlowLayout.ALIGN_CENTER);
			layoutFFigureExpressionActivityNodeFigureRectangleBody.setMajorSpacing(0);
			layoutFFigureExpressionActivityNodeFigureRectangleBody.setMinorSpacing(0);
			layoutFFigureExpressionActivityNodeFigureRectangleBody.setHorizontal(true);

			fFigureExpressionActivityNodeFigureRectangleBody.setLayoutManager(layoutFFigureExpressionActivityNodeFigureRectangleBody);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureExpressionActivityNodeFigureNameLabel()
		{
			return fFigureExpressionActivityNodeFigureNameLabel;
		}

		/**
		 * @generated
		 */
		public RectangleFigure getFigureExpressionActivityNodeFigureRectangleBody()
		{
			return fFigureExpressionActivityNodeFigureRectangleBody;
		}

	}

	/**
	 * @generated
	 */
	static final Color	THIS_BACK											= new Color(null, 230, 230, 230);

	/**
	 * @generated
	 */
	static final Font	FFIGUREEXPRESSIONACTIVITYNODEFIGURENAMELABEL_FONT	= new Font(Display.getCurrent(), Display.getDefault()
																					.getSystemFont().getFontData()[0].getName(), 10,
																					SWT.BOLD);

}
