package de.mdelab.mlsdm.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.common.core.command.ICompositeCommand;
import org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand;
import org.eclipse.gmf.runtime.emf.commands.core.command.CompositeTransactionalCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyReferenceCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyReferenceRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlsdm.diagram.edit.commands.ContainmentLinkCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.ContainmentLinkReorientCommand;
import de.mdelab.mlsdm.diagram.edit.commands.ExpressionLinkCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.ExpressionLinkReorientCommand;
import de.mdelab.mlsdm.diagram.edit.commands.MapEntryLinkCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.MapEntryLinkReorientCommand;
import de.mdelab.mlsdm.diagram.edit.commands.MapEntryLinkValueTargetCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.MapEntryLinkValueTargetReorientCommand;
import de.mdelab.mlsdm.diagram.edit.commands.StoryPatternLinkCreateCommand;
import de.mdelab.mlsdm.diagram.edit.commands.StoryPatternLinkReorientCommand;
import de.mdelab.mlsdm.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpressionEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;
import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;

/**
 * @generated
 */
public class StoryPatternObjectItemSemanticEditPolicy extends MlsdmBaseItemSemanticEditPolicy
{

	/**
	 * @generated
	 */
	public StoryPatternObjectItemSemanticEditPolicy()
	{
		super(MlsdmElementTypes.StoryPatternObject_3003);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req)
	{
		View view = (View) getHost().getModel();
		CompositeTransactionalCommand cmd = new CompositeTransactionalCommand(getEditingDomain(), null);
		cmd.setTransactionNestingEnabled(false);
		for (Iterator<?> it = view.getTargetEdges().iterator(); it.hasNext();)
		{
			Edge incomingLink = (Edge) it.next();
			if (MlsdmVisualIDRegistry.getVisualID(incomingLink) == StoryPatternLinkEditPart.VISUAL_ID)
			{
				DestroyElementRequest r = new DestroyElementRequest(incomingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (MlsdmVisualIDRegistry.getVisualID(incomingLink) == ContainmentLinkEditPart.VISUAL_ID)
			{
				DestroyElementRequest r = new DestroyElementRequest(incomingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (MlsdmVisualIDRegistry.getVisualID(incomingLink) == ExpressionLinkEditPart.VISUAL_ID)
			{
				DestroyElementRequest r = new DestroyElementRequest(incomingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (MlsdmVisualIDRegistry.getVisualID(incomingLink) == MapEntryLinkEditPart.VISUAL_ID)
			{
				DestroyElementRequest r = new DestroyElementRequest(incomingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (MlsdmVisualIDRegistry.getVisualID(incomingLink) == MapEntryLinkValueTargetEditPart.VISUAL_ID)
			{
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null, incomingLink
						.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
		}
		for (Iterator<?> it = view.getSourceEdges().iterator(); it.hasNext();)
		{
			Edge outgoingLink = (Edge) it.next();
			if (MlsdmVisualIDRegistry.getVisualID(outgoingLink) == StoryPatternLinkEditPart.VISUAL_ID)
			{
				DestroyElementRequest r = new DestroyElementRequest(outgoingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (MlsdmVisualIDRegistry.getVisualID(outgoingLink) == ContainmentLinkEditPart.VISUAL_ID)
			{
				DestroyElementRequest r = new DestroyElementRequest(outgoingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (MlsdmVisualIDRegistry.getVisualID(outgoingLink) == ExpressionLinkEditPart.VISUAL_ID)
			{
				DestroyElementRequest r = new DestroyElementRequest(outgoingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (MlsdmVisualIDRegistry.getVisualID(outgoingLink) == MapEntryLinkEditPart.VISUAL_ID)
			{
				DestroyElementRequest r = new DestroyElementRequest(outgoingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
		}
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation == null)
		{
			// there are indirectly referenced children, need extra commands: false
			addDestroyChildNodesCommand(cmd);
			addDestroyShortcutsCommand(cmd, view);
			// delete host element
			cmd.add(new DestroyElementCommand(req));
		}
		else
		{
			cmd.add(new DeleteCommand(getEditingDomain(), view));
		}
		return getGEFWrapper(cmd.reduce());
	}

	/**
	 * @generated
	 */
	private void addDestroyChildNodesCommand(ICompositeCommand cmd)
	{
		View view = (View) getHost().getModel();
		for (Iterator<?> nit = view.getChildren().iterator(); nit.hasNext();)
		{
			Node node = (Node) nit.next();
			switch (MlsdmVisualIDRegistry.getVisualID(node))
			{
				case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
					for (Iterator<?> cit = node.getChildren().iterator(); cit.hasNext();)
					{
						Node cnode = (Node) cit.next();
						switch (MlsdmVisualIDRegistry.getVisualID(cnode))
						{
							case MLStringExpression2EditPart.VISUAL_ID:
								cmd.add(new DestroyElementCommand(new DestroyElementRequest(getEditingDomain(), cnode.getElement(), false))); // directlyOwned: true
								// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
								// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
								break;
							case CallActionExpressionEditPart.VISUAL_ID:
								cmd.add(new DestroyElementCommand(new DestroyElementRequest(getEditingDomain(), cnode.getElement(), false))); // directlyOwned: true
								// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
								// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
								break;
						}
					}
					break;
				case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
					for (Iterator<?> cit = node.getChildren().iterator(); cit.hasNext();)
					{
						Node cnode = (Node) cit.next();
						switch (MlsdmVisualIDRegistry.getVisualID(cnode))
						{
							case AttributeAssignmentEditPart.VISUAL_ID:
								cmd.add(new DestroyElementCommand(new DestroyElementRequest(getEditingDomain(), cnode.getElement(), false))); // directlyOwned: true
								// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
								// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
								break;
						}
					}
					break;
			}
		}
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req)
	{
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req) : getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(CreateRelationshipRequest req)
	{
		if (MlsdmElementTypes.StoryPatternLink_4002 == req.getElementType())
		{
			return getGEFWrapper(new StoryPatternLinkCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (MlsdmElementTypes.ContainmentLink_4003 == req.getElementType())
		{
			return getGEFWrapper(new ContainmentLinkCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (MlsdmElementTypes.ExpressionLink_4004 == req.getElementType())
		{
			return getGEFWrapper(new ExpressionLinkCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (MlsdmElementTypes.MapEntryLink_4006 == req.getElementType())
		{
			return getGEFWrapper(new MapEntryLinkCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (MlsdmElementTypes.MapEntryLinkValueTarget_4007 == req.getElementType())
		{
			return null;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(CreateRelationshipRequest req)
	{
		if (MlsdmElementTypes.StoryPatternLink_4002 == req.getElementType())
		{
			return getGEFWrapper(new StoryPatternLinkCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (MlsdmElementTypes.ContainmentLink_4003 == req.getElementType())
		{
			return getGEFWrapper(new ContainmentLinkCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (MlsdmElementTypes.ExpressionLink_4004 == req.getElementType())
		{
			return getGEFWrapper(new ExpressionLinkCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (MlsdmElementTypes.MapEntryLink_4006 == req.getElementType())
		{
			return getGEFWrapper(new MapEntryLinkCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (MlsdmElementTypes.MapEntryLinkValueTarget_4007 == req.getElementType())
		{
			return getGEFWrapper(new MapEntryLinkValueTargetCreateCommand(req, req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EClass based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientRelationshipCommand(ReorientRelationshipRequest req)
	{
		switch (getVisualID(req))
		{
			case StoryPatternLinkEditPart.VISUAL_ID:
				return getGEFWrapper(new StoryPatternLinkReorientCommand(req));
			case ContainmentLinkEditPart.VISUAL_ID:
				return getGEFWrapper(new ContainmentLinkReorientCommand(req));
			case ExpressionLinkEditPart.VISUAL_ID:
				return getGEFWrapper(new ExpressionLinkReorientCommand(req));
			case MapEntryLinkEditPart.VISUAL_ID:
				return getGEFWrapper(new MapEntryLinkReorientCommand(req));
		}
		return super.getReorientRelationshipCommand(req);
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(ReorientReferenceRelationshipRequest req)
	{
		switch (getVisualID(req))
		{
			case MapEntryLinkValueTargetEditPart.VISUAL_ID:
				return getGEFWrapper(new MapEntryLinkValueTargetReorientCommand(req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
