/**
 */
package de.mdelab.mlsdm.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import de.mdelab.mlsdm.Semaphore;
import java.lang.reflect.InvocationTargetException;
import java.util.Map;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Acquire Edge</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.AcquireEdgeImpl#getActivityEdge <em>Activity Edge</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.AcquireEdgeImpl#getSemaphore <em>Semaphore</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AcquireEdgeImpl extends SynchronizationEdgeImpl
		implements
			AcquireEdge {
	/**
	 * The cached value of the '{@link #getActivityEdge() <em>Activity Edge</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getActivityEdge()
	 * @generated
	 * @ordered
	 */
	protected ActivityEdge activityEdge;

	/**
	 * The cached value of the '{@link #getSemaphore() <em>Semaphore</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSemaphore()
	 * @generated
	 * @ordered
	 */
	protected Semaphore semaphore;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected AcquireEdgeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.ACQUIRE_EDGE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityEdge getActivityEdge() {
		return activityEdge;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetActivityEdge(ActivityEdge newActivityEdge,
			NotificationChain msgs) {
		ActivityEdge oldActivityEdge = activityEdge;
		activityEdge = newActivityEdge;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET, MlsdmPackage.ACQUIRE_EDGE__ACTIVITY_EDGE,
					oldActivityEdge, newActivityEdge);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setActivityEdge(ActivityEdge newActivityEdge) {
		if (newActivityEdge != activityEdge) {
			NotificationChain msgs = null;
			if (activityEdge != null)
				msgs = ((InternalEObject) activityEdge).eInverseRemove(this,
						MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES,
						ActivityEdge.class, msgs);
			if (newActivityEdge != null)
				msgs = ((InternalEObject) newActivityEdge).eInverseAdd(this,
						MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES,
						ActivityEdge.class, msgs);
			msgs = basicSetActivityEdge(newActivityEdge, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACQUIRE_EDGE__ACTIVITY_EDGE, newActivityEdge,
					newActivityEdge));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Semaphore getSemaphore() {
		return semaphore;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSemaphore(Semaphore newSemaphore,
			NotificationChain msgs) {
		Semaphore oldSemaphore = semaphore;
		semaphore = newSemaphore;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET, MlsdmPackage.ACQUIRE_EDGE__SEMAPHORE,
					oldSemaphore, newSemaphore);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSemaphore(Semaphore newSemaphore) {
		if (newSemaphore != semaphore) {
			NotificationChain msgs = null;
			if (semaphore != null)
				msgs = ((InternalEObject) semaphore).eInverseRemove(this,
						MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES, Semaphore.class,
						msgs);
			if (newSemaphore != null)
				msgs = ((InternalEObject) newSemaphore).eInverseAdd(this,
						MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES, Semaphore.class,
						msgs);
			msgs = basicSetSemaphore(newSemaphore, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACQUIRE_EDGE__SEMAPHORE, newSemaphore,
					newSemaphore));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ActivityEdgeSpecified(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv ActivityEdgeSpecified:
		 *   let
		 *     severity : Integer[1] = 'AcquireEdge::ActivityEdgeSpecified'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.activityEdge <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Activity edge of acquire edge ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'AcquireEdge::ActivityEdgeSpecified'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_AcquireEdge_c_c_ActivityEdgeSpecified);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_AcquireEdge_c_c_ActivityEdgeSpecified,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlsdmPackage.ACQUIRE_EDGE__ACTIVITY_EDGE :
				if (activityEdge != null)
					msgs = ((InternalEObject) activityEdge).eInverseRemove(this,
							MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES,
							ActivityEdge.class, msgs);
				return basicSetActivityEdge((ActivityEdge) otherEnd, msgs);
			case MlsdmPackage.ACQUIRE_EDGE__SEMAPHORE :
				if (semaphore != null)
					msgs = ((InternalEObject) semaphore).eInverseRemove(this,
							MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES,
							Semaphore.class, msgs);
				return basicSetSemaphore((Semaphore) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlsdmPackage.ACQUIRE_EDGE__ACTIVITY_EDGE :
				return basicSetActivityEdge(null, msgs);
			case MlsdmPackage.ACQUIRE_EDGE__SEMAPHORE :
				return basicSetSemaphore(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlsdmPackage.ACQUIRE_EDGE__ACTIVITY_EDGE :
				return getActivityEdge();
			case MlsdmPackage.ACQUIRE_EDGE__SEMAPHORE :
				return getSemaphore();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlsdmPackage.ACQUIRE_EDGE__ACTIVITY_EDGE :
				setActivityEdge((ActivityEdge) newValue);
				return;
			case MlsdmPackage.ACQUIRE_EDGE__SEMAPHORE :
				setSemaphore((Semaphore) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlsdmPackage.ACQUIRE_EDGE__ACTIVITY_EDGE :
				setActivityEdge((ActivityEdge) null);
				return;
			case MlsdmPackage.ACQUIRE_EDGE__SEMAPHORE :
				setSemaphore((Semaphore) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlsdmPackage.ACQUIRE_EDGE__ACTIVITY_EDGE :
				return activityEdge != null;
			case MlsdmPackage.ACQUIRE_EDGE__SEMAPHORE :
				return semaphore != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlsdmPackage.ACQUIRE_EDGE___ACTIVITY_EDGE_SPECIFIED__DIAGNOSTICCHAIN_MAP :
				return ActivityEdgeSpecified((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // AcquireEdgeImpl
