/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.MlsdmPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Activity Node</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityNodeImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityNodeImpl#getOutgoingEdges <em>Outgoing Edges</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityNodeImpl#getIncomingEdges <em>Incoming Edges</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityNodeImpl#getActivityNodeContainer <em>Activity Node Container</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class ActivityNodeImpl extends MLElementWithUUIDImpl
		implements
			ActivityNode {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The cached value of the '{@link #getOutgoingEdges() <em>Outgoing Edges</em>}' reference list.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getOutgoingEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityEdge> outgoingEdges;

	/**
	 * The cached value of the '{@link #getIncomingEdges() <em>Incoming Edges</em>}' reference list.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getIncomingEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityEdge> incomingEdges;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected ActivityNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.ACTIVITY_NODE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ActivityEdge> getOutgoingEdges() {
		if (outgoingEdges == null) {
			outgoingEdges = new EObjectWithInverseEList<ActivityEdge>(
					ActivityEdge.class, this,
					MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES,
					MlsdmPackage.ACTIVITY_EDGE__SOURCE);
		}
		return outgoingEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ActivityEdge> getIncomingEdges() {
		if (incomingEdges == null) {
			incomingEdges = new EObjectWithInverseEList<ActivityEdge>(
					ActivityEdge.class, this,
					MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES,
					MlsdmPackage.ACTIVITY_EDGE__TARGET);
		}
		return incomingEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityNodeContainer getActivityNodeContainer() {
		if (eContainerFeatureID() != MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER)
			return null;
		return (ActivityNodeContainer) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetActivityNodeContainer(
			ActivityNodeContainer newActivityNodeContainer,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newActivityNodeContainer,
				MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setActivityNodeContainer(
			ActivityNodeContainer newActivityNodeContainer) {
		if (newActivityNodeContainer != eInternalContainer()
				|| (eContainerFeatureID() != MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER
						&& newActivityNodeContainer != null)) {
			if (EcoreUtil.isAncestor(this, newActivityNodeContainer))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newActivityNodeContainer != null)
				msgs = ((InternalEObject) newActivityNodeContainer).eInverseAdd(
						this, MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES,
						ActivityNodeContainer.class, msgs);
			msgs = basicSetActivityNodeContainer(newActivityNodeContainer,
					msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER,
					newActivityNodeContainer, newActivityNodeContainer));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
						.basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getOutgoingEdges())
						.basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getIncomingEdges())
						.basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER :
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetActivityNodeContainer(
						(ActivityNodeContainer) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS :
				return ((InternalEList<?>) getAnnotations())
						.basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES :
				return ((InternalEList<?>) getOutgoingEdges())
						.basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES :
				return ((InternalEList<?>) getIncomingEdges())
						.basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER :
				return basicSetActivityNodeContainer(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER :
				return eInternalContainer().eInverseRemove(this,
						MlsdmPackage.ACTIVITY_NODE_CONTAINER__NODES,
						ActivityNodeContainer.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS :
				return getAnnotations();
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES :
				return getOutgoingEdges();
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES :
				return getIncomingEdges();
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER :
				return getActivityNodeContainer();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS :
				getAnnotations().clear();
				getAnnotations()
						.addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES :
				getOutgoingEdges().clear();
				getOutgoingEdges()
						.addAll((Collection<? extends ActivityEdge>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES :
				getIncomingEdges().clear();
				getIncomingEdges()
						.addAll((Collection<? extends ActivityEdge>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER :
				setActivityNodeContainer((ActivityNodeContainer) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS :
				getAnnotations().clear();
				return;
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES :
				getOutgoingEdges().clear();
				return;
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES :
				getIncomingEdges().clear();
				return;
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER :
				setActivityNodeContainer((ActivityNodeContainer) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS :
				return annotations != null && !annotations.isEmpty();
			case MlsdmPackage.ACTIVITY_NODE__OUTGOING_EDGES :
				return outgoingEdges != null && !outgoingEdges.isEmpty();
			case MlsdmPackage.ACTIVITY_NODE__INCOMING_EDGES :
				return incomingEdges != null && !incomingEdges.isEmpty();
			case MlsdmPackage.ACTIVITY_NODE__ACTIVITY_NODE_CONTAINER :
				return getActivityNodeContainer() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
				case MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS :
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default :
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS :
					return MlsdmPackage.ACTIVITY_NODE__ANNOTATIONS;
				default :
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} // ActivityNodeImpl
