/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Activity Parameter</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityParameterImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityParameterImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityParameterImpl#getType <em>Type</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityParameterImpl#getDirection <em>Direction</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityParameterImpl#getActivity <em>Activity</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ActivityParameterImpl extends MLElementWithUUIDImpl
		implements
			ActivityParameter {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected EClassifier type;

	/**
	 * The default value of the '{@link #getDirection() <em>Direction</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDirection()
	 * @generated
	 * @ordered
	 */
	protected static final ActivityParameterDirectionEnum DIRECTION_EDEFAULT = ActivityParameterDirectionEnum.IN;

	/**
	 * The cached value of the '{@link #getDirection() <em>Direction</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDirection()
	 * @generated
	 * @ordered
	 */
	protected ActivityParameterDirectionEnum direction = DIRECTION_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected ActivityParameterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.ACTIVITY_PARAMETER;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_PARAMETER__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClassifier getType() {
		if (type != null && type.eIsProxy()) {
			InternalEObject oldType = (InternalEObject) type;
			type = (EClassifier) eResolveProxy(oldType);
			if (type != oldType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							MlsdmPackage.ACTIVITY_PARAMETER__TYPE, oldType,
							type));
			}
		}
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EClassifier basicGetType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setType(EClassifier newType) {
		EClassifier oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_PARAMETER__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityParameterDirectionEnum getDirection() {
		return direction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDirection(ActivityParameterDirectionEnum newDirection) {
		ActivityParameterDirectionEnum oldDirection = direction;
		direction = newDirection == null ? DIRECTION_EDEFAULT : newDirection;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION, oldDirection,
					direction));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Activity getActivity() {
		if (eContainerFeatureID() != MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY)
			return null;
		return (Activity) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetActivity(Activity newActivity,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newActivity,
				MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setActivity(Activity newActivity) {
		if (newActivity != eInternalContainer()
				|| (eContainerFeatureID() != MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY
						&& newActivity != null)) {
			if (EcoreUtil.isAncestor(this, newActivity))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newActivity != null)
				msgs = ((InternalEObject) newActivity).eInverseAdd(this,
						MlsdmPackage.ACTIVITY__PARAMETERS, Activity.class,
						msgs);
			msgs = basicSetActivity(newActivity, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY, newActivity,
					newActivity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean DirectionSpecified(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv DirectionSpecified:
		 *   let
		 *     severity : Integer[1] = 'ActivityParameter::DirectionSpecified'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.direction <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Direction of activity parameter ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'ActivityParameter::DirectionSpecified'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_ActivityParameter_c_c_DirectionSpecified);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_ActivityParameter_c_c_DirectionSpecified,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean TypeSpecified(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv TypeSpecified:
		 *   let severity : Integer[1] = 'ActivityParameter::TypeSpecified'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.type <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Type of activity parameter ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'ActivityParameter::TypeSpecified'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_ActivityParameter_c_c_TypeSpecified);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ EClassifier type = this.getType();
			final /*@NonInvalid*/ boolean ne = type != null;
			/*@NonInvalid*/ Boolean status;
			if (ne) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlsdmTables.STR_Type_32_of_32_activity_32_parameter_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_must_32_be_32_specified);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_ActivityParameter_c_c_TypeSpecified,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
						.basicAdd(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY :
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetActivity((Activity) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS :
				return ((InternalEList<?>) getAnnotations())
						.basicRemove(otherEnd, msgs);
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY :
				return basicSetActivity(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY :
				return eInternalContainer().eInverseRemove(this,
						MlsdmPackage.ACTIVITY__PARAMETERS, Activity.class,
						msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS :
				return getAnnotations();
			case MlsdmPackage.ACTIVITY_PARAMETER__NAME :
				return getName();
			case MlsdmPackage.ACTIVITY_PARAMETER__TYPE :
				if (resolve)
					return getType();
				return basicGetType();
			case MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION :
				return getDirection();
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY :
				return getActivity();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS :
				getAnnotations().clear();
				getAnnotations()
						.addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__NAME :
				setName((String) newValue);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__TYPE :
				setType((EClassifier) newValue);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION :
				setDirection((ActivityParameterDirectionEnum) newValue);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY :
				setActivity((Activity) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS :
				getAnnotations().clear();
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__NAME :
				setName(NAME_EDEFAULT);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__TYPE :
				setType((EClassifier) null);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION :
				setDirection(DIRECTION_EDEFAULT);
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY :
				setActivity((Activity) null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS :
				return annotations != null && !annotations.isEmpty();
			case MlsdmPackage.ACTIVITY_PARAMETER__NAME :
				return NAME_EDEFAULT == null
						? name != null
						: !NAME_EDEFAULT.equals(name);
			case MlsdmPackage.ACTIVITY_PARAMETER__TYPE :
				return type != null;
			case MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION :
				return direction != DIRECTION_EDEFAULT;
			case MlsdmPackage.ACTIVITY_PARAMETER__ACTIVITY :
				return getActivity() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
				case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS :
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default :
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class) {
			switch (derivedFeatureID) {
				case MlsdmPackage.ACTIVITY_PARAMETER__NAME :
					return MlcorePackage.ML_NAMED_ELEMENT__NAME;
				default :
					return -1;
			}
		}
		if (baseClass == MLTypedElement.class) {
			switch (derivedFeatureID) {
				case MlsdmPackage.ACTIVITY_PARAMETER__TYPE :
					return MlcorePackage.ML_TYPED_ELEMENT__TYPE;
				default :
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS :
					return MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS;
				default :
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_NAMED_ELEMENT__NAME :
					return MlsdmPackage.ACTIVITY_PARAMETER__NAME;
				default :
					return -1;
			}
		}
		if (baseClass == MLTypedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_TYPED_ELEMENT__TYPE :
					return MlsdmPackage.ACTIVITY_PARAMETER__TYPE;
				default :
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlsdmPackage.ACTIVITY_PARAMETER___DIRECTION_SPECIFIED__DIAGNOSTICCHAIN_MAP :
				return DirectionSpecified((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.ACTIVITY_PARAMETER___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP :
				return TypeSpecified((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", direction: ");
		result.append(direction);
		result.append(')');
		return result.toString();
	}

} // ActivityParameterImpl
