/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation;
import org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanNotOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.OrderedSetValue;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ExpressionActivityNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Expression Activity Node</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.ExpressionActivityNodeImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ExpressionActivityNodeImpl#getExpressions <em>Expressions</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ExpressionActivityNodeImpl extends ActivityNodeImpl
		implements
			ExpressionActivityNode {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getExpressions() <em>Expressions</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getExpressions()
	 * @generated
	 * @ordered
	 */
	protected EList<MLExpression> expressions;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected ExpressionActivityNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.EXPRESSION_ACTIVITY_NODE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.EXPRESSION_ACTIVITY_NODE__NAME, oldName,
					name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLExpression> getExpressions() {
		if (expressions == null) {
			expressions = new EObjectContainmentEList<MLExpression>(
					MLExpression.class, this,
					MlsdmPackage.EXPRESSION_ACTIVITY_NODE__EXPRESSIONS);
		}
		return expressions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean OneOutgoingEdge(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv OneOutgoingEdge:
		 *   let
		 *     severity : Integer[1] = 'ExpressionActivityNode::OneOutgoingEdge'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.outgoingEdges->size() = 1
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Expression activity node ' +
		 *               self.toString() + ' must have one outgoing edge.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'ExpressionActivityNode::OneOutgoingEdge'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_ExpressionActivityNode_c_c_OneOutgoingEdge);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ List<ActivityEdge> outgoingEdges = this
					.getOutgoingEdges();
			final /*@NonInvalid*/ SetValue BOXED_outgoingEdges = idResolver
					.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge,
							outgoingEdges);
			final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
					.evaluate(BOXED_outgoingEdges);
			final /*@NonInvalid*/ boolean eq = size.equals(MlsdmTables.INT_1);
			/*@NonInvalid*/ Boolean status;
			if (eq) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlsdmTables.STR_Expression_32_activity_32_node_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_must_32_have_32_one_32_outgoing_32_edge);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_ExpressionActivityNode_c_c_OneOutgoingEdge,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean OneIncomingEdge(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv OneIncomingEdge:
		 *   let
		 *     severity : Integer[1] = 'ExpressionActivityNode::OneIncomingEdge'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.incomingEdges->size() = 1
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Expression activity node ' +
		 *               self.toString() + ' must have one incoming edge.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'ExpressionActivityNode::OneIncomingEdge'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_ExpressionActivityNode_c_c_OneIncomingEdge);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ List<ActivityEdge> incomingEdges = this
					.getIncomingEdges();
			final /*@NonInvalid*/ SetValue BOXED_incomingEdges = idResolver
					.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge,
							incomingEdges);
			final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
					.evaluate(BOXED_incomingEdges);
			final /*@NonInvalid*/ boolean eq = size.equals(MlsdmTables.INT_1);
			/*@NonInvalid*/ Boolean status;
			if (eq) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlsdmTables.STR_Expression_32_activity_32_node_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_must_32_have_32_one_32_incoming_32_edge);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_ExpressionActivityNode_c_c_OneIncomingEdge,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ExpressionSpecified(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv ExpressionSpecified:
		 *   let
		 *     severity : Integer[1] = 'ExpressionActivityNode::ExpressionSpecified'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if not self.expressions->isEmpty()
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Expression of expression activity node ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'ExpressionActivityNode::ExpressionSpecified'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_ExpressionActivityNode_c_c_ExpressionSpecified);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ List<MLExpression> expressions = this
					.getExpressions();
			final /*@NonInvalid*/ OrderedSetValue BOXED_expressions = idResolver
					.createOrderedSetOfAll(MlsdmTables.ORD_CLSSid_MLExpression,
							expressions);
			final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE
					.evaluate(BOXED_expressions).booleanValue();
			final /*@NonInvalid*/ Boolean not = BooleanNotOperation.INSTANCE
					.evaluate(isEmpty);
			if (not == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (not) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlsdmTables.STR_Expression_32_of_32_expression_32_activity_32_node_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_must_32_be_32_specified);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_ExpressionActivityNode_c_c_ExpressionSpecified,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE__EXPRESSIONS :
				return ((InternalEList<?>) getExpressions())
						.basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE__NAME :
				return getName();
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE__EXPRESSIONS :
				return getExpressions();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE__NAME :
				setName((String) newValue);
				return;
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE__EXPRESSIONS :
				getExpressions().clear();
				getExpressions()
						.addAll((Collection<? extends MLExpression>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE__NAME :
				setName(NAME_EDEFAULT);
				return;
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE__EXPRESSIONS :
				getExpressions().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE__NAME :
				return NAME_EDEFAULT == null
						? name != null
						: !NAME_EDEFAULT.equals(name);
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE__EXPRESSIONS :
				return expressions != null && !expressions.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLNamedElement.class) {
			switch (derivedFeatureID) {
				case MlsdmPackage.EXPRESSION_ACTIVITY_NODE__NAME :
					return MlcorePackage.ML_NAMED_ELEMENT__NAME;
				default :
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLNamedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_NAMED_ELEMENT__NAME :
					return MlsdmPackage.EXPRESSION_ACTIVITY_NODE__NAME;
				default :
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE___ONE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP :
				return OneOutgoingEdge((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE___ONE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP :
				return OneIncomingEdge((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE___EXPRESSION_SPECIFIED__DIAGNOSTICCHAIN_MAP :
				return ExpressionSpecified((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} // ExpressionActivityNodeImpl
