/**
 */
package de.mdelab.mlsdm.impl;

import de.mdelab.mlsdm.ActivityEdge;
import org.eclipse.emf.ecore.EClass;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation;
import org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlsdm.InitialNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Initial Node</b></em>'. <!-- end-user-doc -->
 *
 * @generated
 */
public class InitialNodeImpl extends ActivityNodeImpl implements InitialNode {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected InitialNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.INITIAL_NODE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean InitialNodeIncomingEdge(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv InitialNodeIncomingEdge:
		 *   let
		 *     severity : Integer[1] = 'InitialNode::InitialNodeIncomingEdge'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.incomingEdges->isEmpty()
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The initial node ' +
		 *               self.toString() + ' must not have an incoming edge.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'InitialNode::InitialNodeIncomingEdge'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_InitialNode_c_c_InitialNodeIncomingEdge);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ List<ActivityEdge> incomingEdges = this
					.getIncomingEdges();
			final /*@NonInvalid*/ SetValue BOXED_incomingEdges = idResolver
					.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge,
							incomingEdges);
			final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE
					.evaluate(BOXED_incomingEdges).booleanValue();
			/*@NonInvalid*/ Boolean status;
			if (isEmpty) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(MlsdmTables.STR_The_32_initial_32_node_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_must_32_not_32_have_32_an_32_incoming_32_edge);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_InitialNode_c_c_InitialNodeIncomingEdge,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean InitialNodeOutgoingEdge(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv InitialNodeOutgoingEdge:
		 *   let
		 *     severity : Integer[1] = 'InitialNode::InitialNodeOutgoingEdge'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.outgoingEdges->size() = 1
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'The initial node ' +
		 *               self.toString() + ' must have exactly one outgoing edge.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'InitialNode::InitialNodeOutgoingEdge'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_InitialNode_c_c_InitialNodeOutgoingEdge);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ List<ActivityEdge> outgoingEdges = this
					.getOutgoingEdges();
			final /*@NonInvalid*/ SetValue BOXED_outgoingEdges = idResolver
					.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge,
							outgoingEdges);
			final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
					.evaluate(BOXED_outgoingEdges);
			final /*@NonInvalid*/ boolean eq = size.equals(MlsdmTables.INT_1);
			/*@NonInvalid*/ Boolean status;
			if (eq) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(MlsdmTables.STR_The_32_initial_32_node_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_must_32_have_32_exactly_32_one_32_outgoing_32_edge);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_InitialNode_c_c_InitialNodeOutgoingEdge,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlsdmPackage.INITIAL_NODE___INITIAL_NODE_INCOMING_EDGE__DIAGNOSTICCHAIN_MAP :
				return InitialNodeIncomingEdge(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.INITIAL_NODE___INITIAL_NODE_OUTGOING_EDGE__DIAGNOSTICCHAIN_MAP :
				return InitialNodeOutgoingEdge(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // InitialNodeImpl
