/**
 */
package de.mdelab.mlsdm.impl;

import de.mdelab.mlsdm.*;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityEdgeGuardEnum;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;
import de.mdelab.mlsdm.DecisionMergeNode;
import de.mdelab.mlsdm.ExpressionActivityNode;
import de.mdelab.mlsdm.FlowFinalNode;
import de.mdelab.mlsdm.ForkJoinNode;
import de.mdelab.mlsdm.InitialNode;
import de.mdelab.mlsdm.MlsdmFactory;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.OutputParameterValue;
import de.mdelab.mlsdm.ReleaseEdge;
import de.mdelab.mlsdm.Semaphore;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StoryNodeSemanticsEnum;
import de.mdelab.mlsdm.StructuredNode;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class MlsdmFactoryImpl extends EFactoryImpl implements MlsdmFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public static MlsdmFactory init() {
		try {
			MlsdmFactory theMlsdmFactory = (MlsdmFactory) EPackage.Registry.INSTANCE
					.getEFactory(MlsdmPackage.eNS_URI);
			if (theMlsdmFactory != null) {
				return theMlsdmFactory;
			}
		} catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new MlsdmFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public MlsdmFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case MlsdmPackage.ACTIVITY :
				return createActivity();
			case MlsdmPackage.ACTIVITY_EDGE :
				return createActivityEdge();
			case MlsdmPackage.INITIAL_NODE :
				return createInitialNode();
			case MlsdmPackage.FLOW_FINAL_NODE :
				return createFlowFinalNode();
			case MlsdmPackage.ACTIVITY_FINAL_NODE :
				return createActivityFinalNode();
			case MlsdmPackage.EXPRESSION_ACTIVITY_NODE :
				return createExpressionActivityNode();
			case MlsdmPackage.DECISION_MERGE_NODE :
				return createDecisionMergeNode();
			case MlsdmPackage.FORK_JOIN_NODE :
				return createForkJoinNode();
			case MlsdmPackage.STORY_NODE :
				return createStoryNode();
			case MlsdmPackage.STRUCTURED_NODE :
				return createStructuredNode();
			case MlsdmPackage.SEMAPHORE :
				return createSemaphore();
			case MlsdmPackage.ACQUIRE_EDGE :
				return createAcquireEdge();
			case MlsdmPackage.RELEASE_EDGE :
				return createReleaseEdge();
			case MlsdmPackage.ACTIVITY_PARAMETER :
				return createActivityParameter();
			case MlsdmPackage.OUTPUT_PARAMETER_VALUE :
				return createOutputParameterValue();
			default :
				throw new IllegalArgumentException("The class '"
						+ eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case MlsdmPackage.ACTIVITY_EDGE_GUARD_ENUM :
				return createActivityEdgeGuardEnumFromString(eDataType,
						initialValue);
			case MlsdmPackage.STORY_NODE_SEMANTICS_ENUM :
				return createStoryNodeSemanticsEnumFromString(eDataType,
						initialValue);
			case MlsdmPackage.ACTIVITY_PARAMETER_DIRECTION_ENUM :
				return createActivityParameterDirectionEnumFromString(eDataType,
						initialValue);
			default :
				throw new IllegalArgumentException("The datatype '"
						+ eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case MlsdmPackage.ACTIVITY_EDGE_GUARD_ENUM :
				return convertActivityEdgeGuardEnumToString(eDataType,
						instanceValue);
			case MlsdmPackage.STORY_NODE_SEMANTICS_ENUM :
				return convertStoryNodeSemanticsEnumToString(eDataType,
						instanceValue);
			case MlsdmPackage.ACTIVITY_PARAMETER_DIRECTION_ENUM :
				return convertActivityParameterDirectionEnumToString(eDataType,
						instanceValue);
			default :
				throw new IllegalArgumentException("The datatype '"
						+ eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Activity createActivity() {
		ActivityImpl activity = new ActivityImpl();
		return activity;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityEdge createActivityEdge() {
		ActivityEdgeImpl activityEdge = new ActivityEdgeImpl();
		return activityEdge;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public InitialNode createInitialNode() {
		InitialNodeImpl initialNode = new InitialNodeImpl();
		return initialNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public FlowFinalNode createFlowFinalNode() {
		FlowFinalNodeImpl flowFinalNode = new FlowFinalNodeImpl();
		return flowFinalNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityFinalNode createActivityFinalNode() {
		ActivityFinalNodeImpl activityFinalNode = new ActivityFinalNodeImpl();
		return activityFinalNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExpressionActivityNode createExpressionActivityNode() {
		ExpressionActivityNodeImpl expressionActivityNode = new ExpressionActivityNodeImpl();
		return expressionActivityNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public DecisionMergeNode createDecisionMergeNode() {
		DecisionMergeNodeImpl decisionMergeNode = new DecisionMergeNodeImpl();
		return decisionMergeNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ForkJoinNode createForkJoinNode() {
		ForkJoinNodeImpl forkJoinNode = new ForkJoinNodeImpl();
		return forkJoinNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryNode createStoryNode() {
		StoryNodeImpl storyNode = new StoryNodeImpl();
		return storyNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StructuredNode createStructuredNode() {
		StructuredNodeImpl structuredNode = new StructuredNodeImpl();
		return structuredNode;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Semaphore createSemaphore() {
		SemaphoreImpl semaphore = new SemaphoreImpl();
		return semaphore;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public AcquireEdge createAcquireEdge() {
		AcquireEdgeImpl acquireEdge = new AcquireEdgeImpl();
		return acquireEdge;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ReleaseEdge createReleaseEdge() {
		ReleaseEdgeImpl releaseEdge = new ReleaseEdgeImpl();
		return releaseEdge;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityParameter createActivityParameter() {
		ActivityParameterImpl activityParameter = new ActivityParameterImpl();
		return activityParameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public OutputParameterValue createOutputParameterValue() {
		OutputParameterValueImpl outputParameterValue = new OutputParameterValueImpl();
		return outputParameterValue;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public ActivityEdgeGuardEnum createActivityEdgeGuardEnumFromString(
			EDataType eDataType, String initialValue) {
		ActivityEdgeGuardEnum result = ActivityEdgeGuardEnum.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException("The value '" + initialValue
					+ "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String convertActivityEdgeGuardEnumToString(EDataType eDataType,
			Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public StoryNodeSemanticsEnum createStoryNodeSemanticsEnumFromString(
			EDataType eDataType, String initialValue) {
		StoryNodeSemanticsEnum result = StoryNodeSemanticsEnum
				.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException("The value '" + initialValue
					+ "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String convertStoryNodeSemanticsEnumToString(EDataType eDataType,
			Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public ActivityParameterDirectionEnum createActivityParameterDirectionEnumFromString(
			EDataType eDataType, String initialValue) {
		ActivityParameterDirectionEnum result = ActivityParameterDirectionEnum
				.get(initialValue);
		if (result == null)
			throw new IllegalArgumentException("The value '" + initialValue
					+ "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String convertActivityParameterDirectionEnumToString(
			EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MlsdmPackage getMlsdmPackage() {
		return (MlsdmPackage) getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static MlsdmPackage getPackage() {
		return MlsdmPackage.eINSTANCE;
	}

} // MlsdmFactoryImpl
