/**
 */
package de.mdelab.mlsdm.impl;

import java.util.Collection;

import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableGreaterThanEqualOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableGreaterThanOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlsdm.AcquireEdge;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import de.mdelab.mlsdm.ReleaseEdge;
import de.mdelab.mlsdm.Semaphore;
import java.lang.reflect.InvocationTargetException;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Semaphore</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getActivityNodeContainer <em>Activity Node Container</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getTokenCount <em>Token Count</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getAcquireEdges <em>Acquire Edges</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.SemaphoreImpl#getReleaseEdges <em>Release Edges</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SemaphoreImpl extends MLElementWithUUIDImpl implements Semaphore {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getTokenCount() <em>Token Count</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getTokenCount()
	 * @generated
	 * @ordered
	 */
	protected static final int TOKEN_COUNT_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getTokenCount() <em>Token Count</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getTokenCount()
	 * @generated
	 * @ordered
	 */
	protected int tokenCount = TOKEN_COUNT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAcquireEdges() <em>Acquire Edges</em>}' reference list.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getAcquireEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<AcquireEdge> acquireEdges;

	/**
	 * The cached value of the '{@link #getReleaseEdges() <em>Release Edges</em>}' reference list.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getReleaseEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<ReleaseEdge> releaseEdges;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected SemaphoreImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.SEMAPHORE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlsdmPackage.SEMAPHORE__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.SEMAPHORE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityNodeContainer getActivityNodeContainer() {
		if (eContainerFeatureID() != MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER)
			return null;
		return (ActivityNodeContainer) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetActivityNodeContainer(
			ActivityNodeContainer newActivityNodeContainer,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newActivityNodeContainer,
				MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setActivityNodeContainer(
			ActivityNodeContainer newActivityNodeContainer) {
		if (newActivityNodeContainer != eInternalContainer()
				|| (eContainerFeatureID() != MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER
						&& newActivityNodeContainer != null)) {
			if (EcoreUtil.isAncestor(this, newActivityNodeContainer))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newActivityNodeContainer != null)
				msgs = ((InternalEObject) newActivityNodeContainer).eInverseAdd(
						this, MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES,
						ActivityNodeContainer.class, msgs);
			msgs = basicSetActivityNodeContainer(newActivityNodeContainer,
					msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER,
					newActivityNodeContainer, newActivityNodeContainer));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getTokenCount() {
		return tokenCount;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTokenCount(int newTokenCount) {
		int oldTokenCount = tokenCount;
		tokenCount = newTokenCount;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.SEMAPHORE__TOKEN_COUNT, oldTokenCount,
					tokenCount));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AcquireEdge> getAcquireEdges() {
		if (acquireEdges == null) {
			acquireEdges = new EObjectWithInverseEList<AcquireEdge>(
					AcquireEdge.class, this,
					MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES,
					MlsdmPackage.ACQUIRE_EDGE__SEMAPHORE);
		}
		return acquireEdges;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ReleaseEdge> getReleaseEdges() {
		if (releaseEdges == null) {
			releaseEdges = new EObjectWithInverseEList<ReleaseEdge>(
					ReleaseEdge.class, this,
					MlsdmPackage.SEMAPHORE__RELEASE_EDGES,
					MlsdmPackage.RELEASE_EDGE__SEMAPHORE);
		}
		return releaseEdges;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean TokenCountNotNegative(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv TokenCountNotNegative:
		 *   let severity : Integer[1] = 'Semaphore::TokenCountNotNegative'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.tokenCount >= 0
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Token count of semaphore ' +
		 *               self.toString() + ' may not be negative.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'Semaphore::TokenCountNotNegative'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_Semaphore_c_c_TokenCountNotNegative);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ int tokenCount = this.getTokenCount();
			final /*@NonInvalid*/ IntegerValue BOXED_tokenCount = ValueUtil
					.integerValueOf(tokenCount);
			final /*@NonInvalid*/ boolean ge = OclComparableGreaterThanEqualOperation.INSTANCE
					.evaluate(executor, BOXED_tokenCount, MlsdmTables.INT_0)
					.booleanValue();
			/*@NonInvalid*/ Boolean status;
			if (ge) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlsdmTables.STR_Token_32_count_32_of_32_semaphore_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_may_32_not_32_be_32_negative);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_Semaphore_c_c_TokenCountNotNegative,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ReleaseEdge(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv ReleaseEdge:
		 *   let severity : Integer[1] = 'Semaphore::ReleaseEdge'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.releaseEdges->size() > 0
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Semaphore ' +
		 *               self.toString() + ' must have at least one release edge.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'Semaphore::ReleaseEdge'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor, MlsdmTables.STR_Semaphore_c_c_ReleaseEdge);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ List<ReleaseEdge> releaseEdges = this
					.getReleaseEdges();
			final /*@NonInvalid*/ SetValue BOXED_releaseEdges = idResolver
					.createSetOfAll(MlsdmTables.SET_CLSSid_ReleaseEdge,
							releaseEdges);
			final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
					.evaluate(BOXED_releaseEdges);
			final /*@NonInvalid*/ boolean gt = OclComparableGreaterThanOperation.INSTANCE
					.evaluate(executor, size, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Boolean status;
			if (gt) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(MlsdmTables.STR_Semaphore_32, toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_must_32_have_32_at_32_least_32_one_32_release_32_edge);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_Semaphore_c_c_ReleaseEdge, this,
							(Object) null, diagnostics, context, (Object) null,
							severity_0, symbol_2, MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean AcquireEdge(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv AcquireEdge:
		 *   let severity : Integer[1] = 'Semaphore::AcquireEdge'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.acquireEdges->size() > 0
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Semaphore ' +
		 *               self.toString() + ' must have at least one acquire edge.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'Semaphore::AcquireEdge'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor, MlsdmTables.STR_Semaphore_c_c_AcquireEdge);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ List<AcquireEdge> acquireEdges = this
					.getAcquireEdges();
			final /*@NonInvalid*/ SetValue BOXED_acquireEdges = idResolver
					.createSetOfAll(MlsdmTables.SET_CLSSid_AcquireEdge,
							acquireEdges);
			final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
					.evaluate(BOXED_acquireEdges);
			final /*@NonInvalid*/ boolean gt = OclComparableGreaterThanOperation.INSTANCE
					.evaluate(executor, size, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ Boolean status;
			if (gt) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(MlsdmTables.STR_Semaphore_32, toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_must_32_have_32_at_32_least_32_one_32_acquire_32_edge);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_Semaphore_c_c_AcquireEdge, this,
							(Object) null, diagnostics, context, (Object) null,
							severity_0, symbol_2, MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
						.basicAdd(otherEnd, msgs);
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER :
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetActivityNodeContainer(
						(ActivityNodeContainer) otherEnd, msgs);
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getAcquireEdges())
						.basicAdd(otherEnd, msgs);
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES :
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getReleaseEdges())
						.basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS :
				return ((InternalEList<?>) getAnnotations())
						.basicRemove(otherEnd, msgs);
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER :
				return basicSetActivityNodeContainer(null, msgs);
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES :
				return ((InternalEList<?>) getAcquireEdges())
						.basicRemove(otherEnd, msgs);
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES :
				return ((InternalEList<?>) getReleaseEdges())
						.basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER :
				return eInternalContainer().eInverseRemove(this,
						MlsdmPackage.ACTIVITY_NODE_CONTAINER__SEMAPHORES,
						ActivityNodeContainer.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS :
				return getAnnotations();
			case MlsdmPackage.SEMAPHORE__NAME :
				return getName();
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER :
				return getActivityNodeContainer();
			case MlsdmPackage.SEMAPHORE__TOKEN_COUNT :
				return getTokenCount();
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES :
				return getAcquireEdges();
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES :
				return getReleaseEdges();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS :
				getAnnotations().clear();
				getAnnotations()
						.addAll((Collection<? extends MLAnnotation>) newValue);
				return;
			case MlsdmPackage.SEMAPHORE__NAME :
				setName((String) newValue);
				return;
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER :
				setActivityNodeContainer((ActivityNodeContainer) newValue);
				return;
			case MlsdmPackage.SEMAPHORE__TOKEN_COUNT :
				setTokenCount((Integer) newValue);
				return;
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES :
				getAcquireEdges().clear();
				getAcquireEdges()
						.addAll((Collection<? extends AcquireEdge>) newValue);
				return;
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES :
				getReleaseEdges().clear();
				getReleaseEdges()
						.addAll((Collection<? extends ReleaseEdge>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS :
				getAnnotations().clear();
				return;
			case MlsdmPackage.SEMAPHORE__NAME :
				setName(NAME_EDEFAULT);
				return;
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER :
				setActivityNodeContainer((ActivityNodeContainer) null);
				return;
			case MlsdmPackage.SEMAPHORE__TOKEN_COUNT :
				setTokenCount(TOKEN_COUNT_EDEFAULT);
				return;
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES :
				getAcquireEdges().clear();
				return;
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES :
				getReleaseEdges().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS :
				return annotations != null && !annotations.isEmpty();
			case MlsdmPackage.SEMAPHORE__NAME :
				return NAME_EDEFAULT == null
						? name != null
						: !NAME_EDEFAULT.equals(name);
			case MlsdmPackage.SEMAPHORE__ACTIVITY_NODE_CONTAINER :
				return getActivityNodeContainer() != null;
			case MlsdmPackage.SEMAPHORE__TOKEN_COUNT :
				return tokenCount != TOKEN_COUNT_EDEFAULT;
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES :
				return acquireEdges != null && !acquireEdges.isEmpty();
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES :
				return releaseEdges != null && !releaseEdges.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
				case MlsdmPackage.SEMAPHORE__ANNOTATIONS :
					return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
				default :
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class) {
			switch (derivedFeatureID) {
				case MlsdmPackage.SEMAPHORE__NAME :
					return MlcorePackage.ML_NAMED_ELEMENT__NAME;
				default :
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS :
					return MlsdmPackage.SEMAPHORE__ANNOTATIONS;
				default :
					return -1;
			}
		}
		if (baseClass == MLNamedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_NAMED_ELEMENT__NAME :
					return MlsdmPackage.SEMAPHORE__NAME;
				default :
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlsdmPackage.SEMAPHORE___TOKEN_COUNT_NOT_NEGATIVE__DIAGNOSTICCHAIN_MAP :
				return TokenCountNotNegative((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.SEMAPHORE___RELEASE_EDGE__DIAGNOSTICCHAIN_MAP :
				return ReleaseEdge((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.SEMAPHORE___ACQUIRE_EDGE__DIAGNOSTICCHAIN_MAP :
				return AcquireEdge((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", tokenCount: ");
		result.append(tokenCount);
		result.append(')');
		return result.toString();
	}

} // SemaphoreImpl
