/**
 */
package de.mdelab.mlsdm.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.internal.utilities.PivotUtilInternal;
import org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanAndOperation;
import org.eclipse.ocl.pivot.library.logical.BooleanOrOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.SetValue.Accumulator;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityEdgeGuardEnum;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StoryNodeSemanticsEnum;
import de.mdelab.mlstorypatterns.StoryPattern;
import java.lang.reflect.InvocationTargetException;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Story Node</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.StoryNodeImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.StoryNodeImpl#getStoryPattern <em>Story Pattern</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.StoryNodeImpl#getSemantics <em>Semantics</em>}</li>
 * </ul>
 *
 * @generated
 */
public class StoryNodeImpl extends ActivityNodeImpl implements StoryNode {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStoryPattern() <em>Story Pattern</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStoryPattern()
	 * @generated
	 * @ordered
	 */
	protected StoryPattern storyPattern;

	/**
	 * The default value of the '{@link #getSemantics() <em>Semantics</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSemantics()
	 * @generated
	 * @ordered
	 */
	protected static final StoryNodeSemanticsEnum SEMANTICS_EDEFAULT = StoryNodeSemanticsEnum.SINGLE_MATCH;

	/**
	 * The cached value of the '{@link #getSemantics() <em>Semantics</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSemantics()
	 * @generated
	 * @ordered
	 */
	protected StoryNodeSemanticsEnum semantics = SEMANTICS_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StoryNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.STORY_NODE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.STORY_NODE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPattern getStoryPattern() {
		return storyPattern;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStoryPattern(StoryPattern newStoryPattern,
			NotificationChain msgs) {
		StoryPattern oldStoryPattern = storyPattern;
		storyPattern = newStoryPattern;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET, MlsdmPackage.STORY_NODE__STORY_PATTERN,
					oldStoryPattern, newStoryPattern);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setStoryPattern(StoryPattern newStoryPattern) {
		if (newStoryPattern != storyPattern) {
			NotificationChain msgs = null;
			if (storyPattern != null)
				msgs = ((InternalEObject) storyPattern).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE
								- MlsdmPackage.STORY_NODE__STORY_PATTERN,
						null, msgs);
			if (newStoryPattern != null)
				msgs = ((InternalEObject) newStoryPattern).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE
								- MlsdmPackage.STORY_NODE__STORY_PATTERN,
						null, msgs);
			msgs = basicSetStoryPattern(newStoryPattern, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.STORY_NODE__STORY_PATTERN, newStoryPattern,
					newStoryPattern));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryNodeSemanticsEnum getSemantics() {
		return semantics;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSemantics(StoryNodeSemanticsEnum newSemantics) {
		StoryNodeSemanticsEnum oldSemantics = semantics;
		semantics = newSemantics == null ? SEMANTICS_EDEFAULT : newSemantics;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.STORY_NODE__SEMANTICS, oldSemantics,
					semantics));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean IncomingEdge(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv IncomingEdge:
		 *   let severity : Integer[1] = 'StoryNode::IncomingEdge'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.incomingEdges->size() = 1
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else Tuple{message = 'Story node ' +
		 *               self.toString() + ' must have one incoming edge.', status = status}
		 *           endif
		 *       in
		 *         'StoryNode::IncomingEdge'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor, MlsdmTables.STR_StoryNode_c_c_IncomingEdge);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ List<ActivityEdge> incomingEdges = this
					.getIncomingEdges();
			final /*@NonInvalid*/ SetValue BOXED_incomingEdges = idResolver
					.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge,
							incomingEdges);
			final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
					.evaluate(BOXED_incomingEdges);
			final /*@NonInvalid*/ boolean eq = size.equals(MlsdmTables.INT_1);
			/*@NonInvalid*/ Boolean status;
			if (eq) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(MlsdmTables.STR_Story_32_node_32, toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_must_32_have_32_one_32_incoming_32_edge);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_StoryNode_c_c_IncomingEdge, this,
							(Object) null, diagnostics, context, (Object) null,
							severity_0, symbol_2, MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ForEachLoopBody(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv ForEachLoopBody:
		 *   let severity : Integer[1] = 'StoryNode::ForEachLoopBody'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH implies
		 *             self.outgoingEdges->select(e | e.guardType = ActivityEdgeGuardEnum::FOR_EACH)
		 *             ->forAll(e | e.target.oclIsKindOf(StructuredNode))
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Loop body of story node ' +
		 *               self.toString() + ' with FOR_EACH semantics must be contained in a structured node.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryNode::ForEachLoopBody'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_StoryNode_c_c_ForEachLoopBody);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryNodeSemanticsEnum semantics = this
					.getSemantics();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_semantics = MlsdmTables.ENUMid_StoryNodeSemanticsEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(semantics.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_semantics == MlsdmTables.ELITid_FOR_EACH_FRESH_MATCH;
			/*@NonInvalid*/ boolean implies;
			if (eq) {
				final /*@NonInvalid*/ List<ActivityEdge> outgoingEdges = this
						.getOutgoingEdges();
				final /*@NonInvalid*/ SetValue BOXED_outgoingEdges = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge,
								outgoingEdges);
				/*@Thrown*/ SetValue.Accumulator accumulator = ValueUtil
						.createSetAccumulatorValue(
								MlsdmTables.SET_CLSSid_ActivityEdge);
				/*@NonNull*/ Iterator<Object> ITERATOR_e_0 = BOXED_outgoingEdges
						.iterator();
				/*@NonInvalid*/ SetValue select;
				while (true) {
					if (!ITERATOR_e_0.hasNext()) {
						select = accumulator;
						break;
					}
					/*@NonInvalid*/ ActivityEdge e_0 = (ActivityEdge) ITERATOR_e_0
							.next();
					/**
					 * e.guardType = ActivityEdgeGuardEnum::FOR_EACH
					 */
					final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = e_0
							.getGuardType();
					final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
							.getEnumerationLiteralId(ClassUtil
									.nonNullState(guardType.getName()));
					final /*@NonInvalid*/ boolean eq_0 = BOXED_guardType == MlsdmTables.ELITid_FOR_EACH;
					//
					if (eq_0 == ValueUtil.TRUE_VALUE) {
						accumulator.add(e_0);
					}
				}
				/*@Thrown*/ Object accumulator_0 = ValueUtil.TRUE_VALUE;
				/*@NonNull*/ Iterator<Object> ITERATOR_e_1 = select.iterator();
				/*@NonInvalid*/ boolean forAll;
				while (true) {
					if (!ITERATOR_e_1.hasNext()) {
						if (accumulator_0 == ValueUtil.TRUE_VALUE) {
							forAll = ValueUtil.TRUE_VALUE;
						} else {
							throw (InvalidValueException) accumulator_0;
						}
						break;
					}
					/*@NonInvalid*/ ActivityEdge e_1 = (ActivityEdge) ITERATOR_e_1
							.next();
					/**
					 * e.target.oclIsKindOf(StructuredNode)
					 */
					final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_mlsdm_c_c_StructuredNode = idResolver
							.getClass(MlsdmTables.CLSSid_StructuredNode, null);
					final /*@NonInvalid*/ ActivityNode target = e_1.getTarget();
					final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE
							.evaluate(executor, target,
									TYP_mlsdm_c_c_StructuredNode)
							.booleanValue();
					//
					if (oclIsKindOf == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
						forAll = ValueUtil.FALSE_VALUE;
						break; // Stop immediately
					} else if (oclIsKindOf == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
						; // Carry on
					} else { // Impossible badly typed result
						accumulator_0 = new InvalidValueException(
								PivotMessages.NonBooleanBody, "forAll");
					}
				}
				implies = forAll;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(
								MlsdmTables.STR_Loop_32_body_32_of_32_story_32_node_32,
								toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_with_32_FOR_EACH_32_semantics_32_must_32_be_32_contained_32_in_32_a_32_structured_32_node);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_StoryNode_c_c_ForEachLoopBody, this,
							(Object) null, diagnostics, context, (Object) null,
							severity_0, symbol_2, MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean StoryPatternSpecified(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv StoryPatternSpecified:
		 *   let severity : Integer[1] = 'StoryNode::StoryPatternSpecified'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.storyPattern <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else Tuple{message = 'Story node ' +
		 *               self.toString() + ' must contain a story pattern.', status = status}
		 *           endif
		 *       in
		 *         'StoryNode::StoryPatternSpecified'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_StoryNode_c_c_StoryPatternSpecified);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_StoryNode_c_c_StoryPatternSpecified,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean SemanticsSpecified(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv SemanticsSpecified:
		 *   let severity : Integer[1] = 'StoryNode::SemanticsSpecified'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.semantics <> null
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Semantics of story node ' +
		 *               self.toString() + ' must be specified.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryNode::SemanticsSpecified'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_StoryNode_c_c_SemanticsSpecified);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_0;
		if (le) {
			symbol_0 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_StoryNode_c_c_SemanticsSpecified,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, ValueUtil.TRUE_VALUE,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_0 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ForEachMatchOutgoingEdges(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv ForEachMatchOutgoingEdges:
		 *   let
		 *     severity : Integer[1] = 'StoryNode::ForEachMatchOutgoingEdges'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.semantics = StoryNodeSemanticsEnum::FOR_EACH_FRESH_MATCH implies
		 *             self.outgoingEdges->size() = 1 and
		 *             self.outgoingEdges->exists(e | e.guardType = ActivityEdgeGuardEnum::END) or
		 *             self.outgoingEdges->size() = 2 and
		 *             self.outgoingEdges->exists(e | e.guardType = ActivityEdgeGuardEnum::END) and
		 *             self.outgoingEdges->exists(e | e.guardType = ActivityEdgeGuardEnum::FOR_EACH)
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story node ' +
		 *               self.toString() + ' with FOR_EACH semantics must have one outgoing edge with the END guard. It may also have another outgoing edge with the FOR_EACH guard leading to a structured node, which contains the loop body.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryNode::ForEachMatchOutgoingEdges'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_StoryNode_c_c_ForEachMatchOutgoingEdges);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryNodeSemanticsEnum semantics = this
					.getSemantics();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_semantics = MlsdmTables.ENUMid_StoryNodeSemanticsEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(semantics.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_semantics == MlsdmTables.ELITid_FOR_EACH_FRESH_MATCH;
			/*@Thrown*/ Boolean implies;
			if (eq) {
				final /*@NonInvalid*/ List<ActivityEdge> outgoingEdges_0 = this
						.getOutgoingEdges();
				final /*@NonInvalid*/ SetValue BOXED_outgoingEdges_0 = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge,
								outgoingEdges_0);
				final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
						.evaluate(BOXED_outgoingEdges_0);
				final /*@NonInvalid*/ boolean eq_0 = size
						.equals(MlsdmTables.INT_1);
				/*@NonInvalid*/ Boolean and;
				if (eq_0) {
					/*@Thrown*/ Object accumulator = ValueUtil.FALSE_VALUE;
					/*@NonNull*/ Iterator<Object> ITERATOR_e_0 = BOXED_outgoingEdges_0
							.iterator();
					/*@NonInvalid*/ Boolean exists;
					while (true) {
						if (!ITERATOR_e_0.hasNext()) {
							if (accumulator == ValueUtil.FALSE_VALUE) {
								exists = ValueUtil.FALSE_VALUE;
							} else {
								throw (InvalidValueException) accumulator;
							}
							break;
						}
						/*@NonInvalid*/ ActivityEdge e_0 = (ActivityEdge) ITERATOR_e_0
								.next();
						/**
						 * e.guardType = ActivityEdgeGuardEnum::END
						 */
						final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = e_0
								.getGuardType();
						final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
								.getEnumerationLiteralId(ClassUtil
										.nonNullState(guardType.getName()));
						final /*@NonInvalid*/ boolean eq_1 = BOXED_guardType == MlsdmTables.ELITid_END;
						//
						if (eq_1 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
							exists = ValueUtil.TRUE_VALUE;
							break; // Stop immediately
						} else if (eq_1 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
							; // Carry on
						} else { // Impossible badly typed result
							accumulator = new InvalidValueException(
									PivotMessages.NonBooleanBody, "exists");
						}
					}
					and = exists;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				/*@Caught*/ /*@Nullable*/ Object CAUGHT_and_1;
				try {
					final /*@NonInvalid*/ boolean eq_2 = size
							.equals(MlsdmTables.INT_2);
					/*@NonInvalid*/ Boolean and_0;
					if (eq_2) {
						/*@Thrown*/ Object accumulator_0 = ValueUtil.FALSE_VALUE;
						/*@NonNull*/ Iterator<Object> ITERATOR_e_1 = BOXED_outgoingEdges_0
								.iterator();
						/*@NonInvalid*/ Boolean exists_0;
						while (true) {
							if (!ITERATOR_e_1.hasNext()) {
								if (accumulator_0 == ValueUtil.FALSE_VALUE) {
									exists_0 = ValueUtil.FALSE_VALUE;
								} else {
									throw (InvalidValueException) accumulator_0;
								}
								break;
							}
							/*@NonInvalid*/ ActivityEdge e_1 = (ActivityEdge) ITERATOR_e_1
									.next();
							/**
							 * e.guardType = ActivityEdgeGuardEnum::END
							 */
							final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType_0 = e_1
									.getGuardType();
							final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType_0 = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
									.getEnumerationLiteralId(
											ClassUtil.nonNullState(
													guardType_0.getName()));
							final /*@NonInvalid*/ boolean eq_3 = BOXED_guardType_0 == MlsdmTables.ELITid_END;
							//
							if (eq_3 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
								exists_0 = ValueUtil.TRUE_VALUE;
								break; // Stop immediately
							} else if (eq_3 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
								; // Carry on
							} else { // Impossible badly typed result
								accumulator_0 = new InvalidValueException(
										PivotMessages.NonBooleanBody, "exists");
							}
						}
						and_0 = exists_0;
					} else {
						and_0 = ValueUtil.FALSE_VALUE;
					}
					/*@Thrown*/ Object accumulator_1 = ValueUtil.FALSE_VALUE;
					/*@NonNull*/ Iterator<Object> ITERATOR_e_2 = BOXED_outgoingEdges_0
							.iterator();
					/*@NonInvalid*/ Boolean exists_1;
					while (true) {
						if (!ITERATOR_e_2.hasNext()) {
							if (accumulator_1 == ValueUtil.FALSE_VALUE) {
								exists_1 = ValueUtil.FALSE_VALUE;
							} else {
								throw (InvalidValueException) accumulator_1;
							}
							break;
						}
						/*@NonInvalid*/ ActivityEdge e_2 = (ActivityEdge) ITERATOR_e_2
								.next();
						/**
						 * e.guardType = ActivityEdgeGuardEnum::FOR_EACH
						 */
						final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType_1 = e_2
								.getGuardType();
						final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType_1 = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
								.getEnumerationLiteralId(ClassUtil
										.nonNullState(guardType_1.getName()));
						final /*@NonInvalid*/ boolean eq_4 = BOXED_guardType_1 == MlsdmTables.ELITid_FOR_EACH;
						//
						if (eq_4 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
							exists_1 = ValueUtil.TRUE_VALUE;
							break; // Stop immediately
						} else if (eq_4 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
							; // Carry on
						} else { // Impossible badly typed result
							accumulator_1 = new InvalidValueException(
									PivotMessages.NonBooleanBody, "exists");
						}
					}
					final /*@Thrown*/ Boolean and_1 = BooleanAndOperation.INSTANCE
							.evaluate(and_0, exists_1);
					CAUGHT_and_1 = and_1;
				} catch (Exception e) {
					CAUGHT_and_1 = ValueUtil.createInvalidValue(e);
				}
				final /*@Thrown*/ Boolean or = BooleanOrOperation.INSTANCE
						.evaluate(and, CAUGHT_and_1);
				implies = or;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			if (implies == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(MlsdmTables.STR_Story_32_node_32, toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_with_32_FOR_EACH_32_semantics_32_must_32_have_32_one_32_outgoing_32_edge_32_with_32_the_32_EN);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_StoryNode_c_c_ForEachMatchOutgoingEdges,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean SingleMatchOutgoingEdges(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		/**
		 *
		 * inv SingleMatchOutgoingEdges:
		 *   let
		 *     severity : Integer[1] = 'StoryNode::SingleMatchOutgoingEdges'.getSeverity()
		 *   in
		 *     if severity <= 0
		 *     then true
		 *     else
		 *       let
		 *         result : OclAny[1] = let
		 *           status : Boolean[?] = if self.semantics = StoryNodeSemanticsEnum::SINGLE_MATCH implies
		 *             self.outgoingEdges->size() = 1 and
		 *             self.outgoingEdges->forAll(e | e.guardType = ActivityEdgeGuardEnum::NONE) or
		 *             self.outgoingEdges->size() = 2 and
		 *             self.outgoingEdges->exists(e | e.guardType = ActivityEdgeGuardEnum::SUCCESS) and
		 *             self.outgoingEdges->exists(e | e.guardType = ActivityEdgeGuardEnum::FAILURE)
		 *           then true
		 *           else null
		 *           endif
		 *         in
		 *           if status = true
		 *           then true
		 *           else
		 *             Tuple{message = 'Story node ' +
		 *               self.toString() + ' with SINGLE_MATCH semantics must have one outgoing edge with no guard or two outgoing edges with SUCCESS and FAILURE guards.', status = status
		 *             }
		 *           endif
		 *       in
		 *         'StoryNode::SingleMatchOutgoingEdges'.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
		 *     endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtilInternal
				.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE
				.evaluate(executor,
						MlsdmTables.STR_StoryNode_c_c_SingleMatchOutgoingEdges);
		final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
				.evaluate(executor, severity_0, MlsdmTables.INT_0)
				.booleanValue();
		/*@NonInvalid*/ Object symbol_3;
		if (le) {
			symbol_3 = ValueUtil.TRUE_VALUE;
		} else {
			final /*@NonInvalid*/ StoryNodeSemanticsEnum semantics = this
					.getSemantics();
			final /*@NonInvalid*/ EnumerationLiteralId BOXED_semantics = MlsdmTables.ENUMid_StoryNodeSemanticsEnum
					.getEnumerationLiteralId(
							ClassUtil.nonNullState(semantics.getName()));
			final /*@NonInvalid*/ boolean eq = BOXED_semantics == MlsdmTables.ELITid_SINGLE_MATCH;
			/*@Thrown*/ Boolean implies;
			if (eq) {
				final /*@NonInvalid*/ List<ActivityEdge> outgoingEdges_0 = this
						.getOutgoingEdges();
				final /*@NonInvalid*/ SetValue BOXED_outgoingEdges_0 = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityEdge,
								outgoingEdges_0);
				final /*@NonInvalid*/ IntegerValue size = CollectionSizeOperation.INSTANCE
						.evaluate(BOXED_outgoingEdges_0);
				final /*@NonInvalid*/ boolean eq_0 = size
						.equals(MlsdmTables.INT_1);
				/*@NonInvalid*/ Boolean and;
				if (eq_0) {
					/*@Thrown*/ Object accumulator = ValueUtil.TRUE_VALUE;
					/*@NonNull*/ Iterator<Object> ITERATOR_e_0 = BOXED_outgoingEdges_0
							.iterator();
					/*@NonInvalid*/ Boolean forAll;
					while (true) {
						if (!ITERATOR_e_0.hasNext()) {
							if (accumulator == ValueUtil.TRUE_VALUE) {
								forAll = ValueUtil.TRUE_VALUE;
							} else {
								throw (InvalidValueException) accumulator;
							}
							break;
						}
						/*@NonInvalid*/ ActivityEdge e_0 = (ActivityEdge) ITERATOR_e_0
								.next();
						/**
						 * e.guardType = ActivityEdgeGuardEnum::NONE
						 */
						final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType = e_0
								.getGuardType();
						final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
								.getEnumerationLiteralId(ClassUtil
										.nonNullState(guardType.getName()));
						final /*@NonInvalid*/ boolean eq_1 = BOXED_guardType == MlsdmTables.ELITid_NONE;
						//
						if (eq_1 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
							forAll = ValueUtil.FALSE_VALUE;
							break; // Stop immediately
						} else if (eq_1 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
							; // Carry on
						} else { // Impossible badly typed result
							accumulator = new InvalidValueException(
									PivotMessages.NonBooleanBody, "forAll");
						}
					}
					and = forAll;
				} else {
					and = ValueUtil.FALSE_VALUE;
				}
				/*@Caught*/ /*@Nullable*/ Object CAUGHT_and_1;
				try {
					final /*@NonInvalid*/ boolean eq_2 = size
							.equals(MlsdmTables.INT_2);
					/*@NonInvalid*/ Boolean and_0;
					if (eq_2) {
						/*@Thrown*/ Object accumulator_0 = ValueUtil.FALSE_VALUE;
						/*@NonNull*/ Iterator<Object> ITERATOR_e_1 = BOXED_outgoingEdges_0
								.iterator();
						/*@NonInvalid*/ Boolean exists;
						while (true) {
							if (!ITERATOR_e_1.hasNext()) {
								if (accumulator_0 == ValueUtil.FALSE_VALUE) {
									exists = ValueUtil.FALSE_VALUE;
								} else {
									throw (InvalidValueException) accumulator_0;
								}
								break;
							}
							/*@NonInvalid*/ ActivityEdge e_1 = (ActivityEdge) ITERATOR_e_1
									.next();
							/**
							 * e.guardType = ActivityEdgeGuardEnum::SUCCESS
							 */
							final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType_0 = e_1
									.getGuardType();
							final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType_0 = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
									.getEnumerationLiteralId(
											ClassUtil.nonNullState(
													guardType_0.getName()));
							final /*@NonInvalid*/ boolean eq_3 = BOXED_guardType_0 == MlsdmTables.ELITid_SUCCESS;
							//
							if (eq_3 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
								exists = ValueUtil.TRUE_VALUE;
								break; // Stop immediately
							} else if (eq_3 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
								; // Carry on
							} else { // Impossible badly typed result
								accumulator_0 = new InvalidValueException(
										PivotMessages.NonBooleanBody, "exists");
							}
						}
						and_0 = exists;
					} else {
						and_0 = ValueUtil.FALSE_VALUE;
					}
					/*@Thrown*/ Object accumulator_1 = ValueUtil.FALSE_VALUE;
					/*@NonNull*/ Iterator<Object> ITERATOR_e_2 = BOXED_outgoingEdges_0
							.iterator();
					/*@NonInvalid*/ Boolean exists_0;
					while (true) {
						if (!ITERATOR_e_2.hasNext()) {
							if (accumulator_1 == ValueUtil.FALSE_VALUE) {
								exists_0 = ValueUtil.FALSE_VALUE;
							} else {
								throw (InvalidValueException) accumulator_1;
							}
							break;
						}
						/*@NonInvalid*/ ActivityEdge e_2 = (ActivityEdge) ITERATOR_e_2
								.next();
						/**
						 * e.guardType = ActivityEdgeGuardEnum::FAILURE
						 */
						final /*@NonInvalid*/ ActivityEdgeGuardEnum guardType_1 = e_2
								.getGuardType();
						final /*@NonInvalid*/ EnumerationLiteralId BOXED_guardType_1 = MlsdmTables.ENUMid_ActivityEdgeGuardEnum
								.getEnumerationLiteralId(ClassUtil
										.nonNullState(guardType_1.getName()));
						final /*@NonInvalid*/ boolean eq_4 = BOXED_guardType_1 == MlsdmTables.ELITid_FAILURE;
						//
						if (eq_4 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
							exists_0 = ValueUtil.TRUE_VALUE;
							break; // Stop immediately
						} else if (eq_4 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
							; // Carry on
						} else { // Impossible badly typed result
							accumulator_1 = new InvalidValueException(
									PivotMessages.NonBooleanBody, "exists");
						}
					}
					final /*@Thrown*/ Boolean and_1 = BooleanAndOperation.INSTANCE
							.evaluate(and_0, exists_0);
					CAUGHT_and_1 = and_1;
				} catch (Exception e) {
					CAUGHT_and_1 = ValueUtil.createInvalidValue(e);
				}
				final /*@Thrown*/ Boolean or = BooleanOrOperation.INSTANCE
						.evaluate(and, CAUGHT_and_1);
				implies = or;
			} else {
				implies = ValueUtil.TRUE_VALUE;
			}
			if (implies == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@NonInvalid*/ Boolean status;
			if (implies) {
				status = ValueUtil.TRUE_VALUE;
			} else {
				status = null;
			}
			final /*@NonInvalid*/ boolean symbol_0 = status == Boolean.TRUE;
			/*@NonInvalid*/ Object symbol_2;
			if (symbol_0) {
				symbol_2 = ValueUtil.TRUE_VALUE;
			} else {
				final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE
						.evaluate(this);
				final /*@NonInvalid*/ String sum = StringConcatOperation.INSTANCE
						.evaluate(MlsdmTables.STR_Story_32_node_32, toString);
				final /*@NonInvalid*/ String sum_0 = StringConcatOperation.INSTANCE
						.evaluate(sum,
								MlsdmTables.STR__32_with_32_SINGLE_MATCH_32_semantics_32_must_32_have_32_one_32_outgoing_32_edge_32_with_32_no);
				final /*@NonInvalid*/ TupleValue symbol_1 = ValueUtil
						.createTupleOfEach(MlsdmTables.TUPLid_, sum_0, status);
				symbol_2 = symbol_1;
			}
			final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
					.evaluate(executor, TypeId.BOOLEAN,
							MlsdmTables.STR_StoryNode_c_c_SingleMatchOutgoingEdges,
							this, (Object) null, diagnostics, context,
							(Object) null, severity_0, symbol_2,
							MlsdmTables.INT_0)
					.booleanValue();
			symbol_3 = logDiagnostic;
		}
		return Boolean.TRUE == symbol_3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MlsdmPackage.STORY_NODE__STORY_PATTERN :
				return basicSetStoryPattern(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MlsdmPackage.STORY_NODE__NAME :
				return getName();
			case MlsdmPackage.STORY_NODE__STORY_PATTERN :
				return getStoryPattern();
			case MlsdmPackage.STORY_NODE__SEMANTICS :
				return getSemantics();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MlsdmPackage.STORY_NODE__NAME :
				setName((String) newValue);
				return;
			case MlsdmPackage.STORY_NODE__STORY_PATTERN :
				setStoryPattern((StoryPattern) newValue);
				return;
			case MlsdmPackage.STORY_NODE__SEMANTICS :
				setSemantics((StoryNodeSemanticsEnum) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MlsdmPackage.STORY_NODE__NAME :
				setName(NAME_EDEFAULT);
				return;
			case MlsdmPackage.STORY_NODE__STORY_PATTERN :
				setStoryPattern((StoryPattern) null);
				return;
			case MlsdmPackage.STORY_NODE__SEMANTICS :
				setSemantics(SEMANTICS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MlsdmPackage.STORY_NODE__NAME :
				return NAME_EDEFAULT == null
						? name != null
						: !NAME_EDEFAULT.equals(name);
			case MlsdmPackage.STORY_NODE__STORY_PATTERN :
				return storyPattern != null;
			case MlsdmPackage.STORY_NODE__SEMANTICS :
				return semantics != SEMANTICS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLNamedElement.class) {
			switch (derivedFeatureID) {
				case MlsdmPackage.STORY_NODE__NAME :
					return MlcorePackage.ML_NAMED_ELEMENT__NAME;
				default :
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID,
			Class<?> baseClass) {
		if (baseClass == MLNamedElement.class) {
			switch (baseFeatureID) {
				case MlcorePackage.ML_NAMED_ELEMENT__NAME :
					return MlsdmPackage.STORY_NODE__NAME;
				default :
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
			case MlsdmPackage.STORY_NODE___INCOMING_EDGE__DIAGNOSTICCHAIN_MAP :
				return IncomingEdge((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.STORY_NODE___FOR_EACH_LOOP_BODY__DIAGNOSTICCHAIN_MAP :
				return ForEachLoopBody((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.STORY_NODE___STORY_PATTERN_SPECIFIED__DIAGNOSTICCHAIN_MAP :
				return StoryPatternSpecified((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.STORY_NODE___SEMANTICS_SPECIFIED__DIAGNOSTICCHAIN_MAP :
				return SemanticsSpecified((DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.STORY_NODE___FOR_EACH_MATCH_OUTGOING_EDGES__DIAGNOSTICCHAIN_MAP :
				return ForEachMatchOutgoingEdges(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
			case MlsdmPackage.STORY_NODE___SINGLE_MATCH_OUTGOING_EDGES__DIAGNOSTICCHAIN_MAP :
				return SingleMatchOutgoingEdges(
						(DiagnosticChain) arguments.get(0),
						(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", semantics: ");
		result.append(semantics);
		result.append(')');
		return result.toString();
	}

} // StoryNodeImpl
