/**
 */
package de.mdelab.mlsdm.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemColorProvider;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITableItemColorProvider;
import org.eclipse.emf.edit.provider.ITableItemFontProvider;
import org.eclipse.emf.edit.provider.ITableItemLabelProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlannotations.MlannotationsFactory;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.provider.MLElementWithUUIDItemProvider;
import de.mdelab.mlexpressions.MlexpressionsFactory;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.MlsdmPackage;

/**
 * This is the item provider adapter for a {@link de.mdelab.mlsdm.ActivityEdge} object.
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * @generated
 */
public class ActivityEdgeItemProvider extends MLElementWithUUIDItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ActivityEdgeItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addSourcePropertyDescriptor(object);
			addTargetPropertyDescriptor(object);
			addGuardTypePropertyDescriptor(object);
			addAcquireEdgesPropertyDescriptor(object);
			addReleaseEdgesPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Source feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addSourcePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_ActivityEdge_source_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_ActivityEdge_source_feature",
						"_UI_ActivityEdge_type"),
				MlsdmPackage.Literals.ACTIVITY_EDGE__SOURCE, true, false, true,
				null, null, null));
	}

	/**
	 * This adds a property descriptor for the Target feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addTargetPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_ActivityEdge_target_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_ActivityEdge_target_feature",
						"_UI_ActivityEdge_type"),
				MlsdmPackage.Literals.ACTIVITY_EDGE__TARGET, true, false, true,
				null, null, null));
	}

	/**
	 * This adds a property descriptor for the Guard Type feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addGuardTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_ActivityEdge_guardType_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_ActivityEdge_guardType_feature",
						"_UI_ActivityEdge_type"),
				MlsdmPackage.Literals.ACTIVITY_EDGE__GUARD_TYPE, true, false,
				false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Acquire Edges feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addAcquireEdgesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_ActivityEdge_acquireEdges_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_ActivityEdge_acquireEdges_feature",
						"_UI_ActivityEdge_type"),
				MlsdmPackage.Literals.ACTIVITY_EDGE__ACQUIRE_EDGES, true, false,
				true, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Release Edges feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addReleaseEdgesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_ActivityEdge_releaseEdges_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_ActivityEdge_releaseEdges_feature",
						"_UI_ActivityEdge_type"),
				MlsdmPackage.Literals.ACTIVITY_EDGE__RELEASE_EDGES, true, false,
				true, null, null, null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(
			Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(
					MlcorePackage.Literals.ML_ANNOTATED_ELEMENT__ANNOTATIONS);
			childrenFeatures
					.add(MlsdmPackage.Literals.ACTIVITY_EDGE__GUARD_EXPRESSION);
			childrenFeatures.add(
					MlsdmPackage.Literals.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns ActivityEdge.gif. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object,
				getResourceLocator().getImage("full/obj16/ActivityEdge"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public String getText(final Object object) {
		String label = this.getString("_UI_ActivityEdge_type");

		final ActivityEdge edge = (ActivityEdge) object;

		final ComposedAdapterFactory factory = new ComposedAdapterFactory(
				EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());

		label += " ";

		if (edge.getSource() != null) {
			label += ((IItemLabelProvider) factory.adapt(edge.getSource(),
					IItemLabelProvider.class)).getText(edge.getSource());
		} else {
			label += "[null]";
		}

		label += " ==> ";

		if (edge.getTarget() != null) {
			label += ((IItemLabelProvider) factory.adapt(edge.getTarget(),
					IItemLabelProvider.class)).getText(edge.getTarget());
		} else {
			label += "[null]";
		}

		return label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ActivityEdge.class)) {
			case MlsdmPackage.ACTIVITY_EDGE__SOURCE :
			case MlsdmPackage.ACTIVITY_EDGE__TARGET :
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_TYPE :
			case MlsdmPackage.ACTIVITY_EDGE__ACQUIRE_EDGES :
			case MlsdmPackage.ACTIVITY_EDGE__RELEASE_EDGES :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), false, true));
				return;
			case MlsdmPackage.ACTIVITY_EDGE__ANNOTATIONS :
			case MlsdmPackage.ACTIVITY_EDGE__GUARD_EXPRESSION :
			case MlsdmPackage.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(
			Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(
				MlcorePackage.Literals.ML_ANNOTATED_ELEMENT__ANNOTATIONS,
				MlannotationsFactory.eINSTANCE.createMLAnnotation()));

		newChildDescriptors.add(createChildParameter(
				MlsdmPackage.Literals.ACTIVITY_EDGE__GUARD_EXPRESSION,
				MlexpressionsFactory.eINSTANCE.createMLStringExpression()));

		newChildDescriptors.add(createChildParameter(
				MlsdmPackage.Literals.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS,
				MlexpressionsFactory.eINSTANCE.createMLStringExpression()));
	}

	/**
	 * This returns the label text for
	 * {@link org.eclipse.emf.edit.command.CreateChildCommand}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child,
			Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify = childFeature == MlsdmPackage.Literals.ACTIVITY_EDGE__GUARD_EXPRESSION
				|| childFeature == MlsdmPackage.Literals.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS;

		if (qualify) {
			return getString("_UI_CreateChild_text2",
					new Object[]{getTypeText(childObject),
							getFeatureText(childFeature), getTypeText(owner)});
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

}
