/**
 */
package de.mdelab.mlsdm.provider;

import java.util.Collection;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage.Registry;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemColorProvider;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITableItemColorProvider;
import org.eclipse.emf.edit.provider.ITableItemFontProvider;
import org.eclipse.emf.edit.provider.ITableItemLabelProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlannotations.MlannotationsFactory;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.provider.MLElementWithUUIDItemProvider;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.MlsdmPackage;

/**
 * This is the item provider adapter for a {@link de.mdelab.mlsdm.ActivityParameter} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ActivityParameterItemProvider
		extends
			MLElementWithUUIDItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ActivityParameterItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addTypePropertyDescriptor(object);
			addDirectionPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_MLNamedElement_name_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_MLNamedElement_name_feature",
						"_UI_MLNamedElement_type"),
				MlcorePackage.Literals.ML_NAMED_ELEMENT__NAME, true, false,
				false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Type feature. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	protected void addTypePropertyDescriptor(final Object object) {
		// itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory)
		// adapterFactory).getRootAdapterFactory(),
		// getResourceLocator(), getString("_UI_MLTypedElement_type_feature"),
		// getString("_UI_PropertyDescriptor_description",
		// "_UI_MLTypedElement_type_feature", "_UI_MLTypedElement_type"),
		// MlcorePackage.Literals.ML_TYPED_ELEMENT__TYPE, true, false, true,
		// null, null, null));

		this.itemPropertyDescriptors.add(new ItemPropertyDescriptor(
				((ComposeableAdapterFactory) this.adapterFactory)
						.getRootAdapterFactory(),
				this.getResourceLocator(),
				this.getString("_UI_MLTypedElement_type_feature"),
				this.getString("_UI_PropertyDescriptor_description",
						"_UI_MLTypedElement_type_feature",
						"_UI_MLTypedElement_type"),
				MlcorePackage.Literals.ML_TYPED_ELEMENT__TYPE, true, false,
				true, null, null, null) {
			@Override
			protected Collection<?> getComboBoxObjects(final Object object) {
				final Collection<Object> set = new HashSet<Object>(
						super.getComboBoxObjects(object));
				set.addAll(EcorePackage.eINSTANCE.getEClassifiers());

				if ((this.feature instanceof EReference)
						&& (object instanceof EObject)) {
					@SuppressWarnings("unchecked")
					final List<EObject> eObjects = (List<EObject>) (List<?>) new LinkedList<Object>(
							set);
					final Resource resource = ((EObject) object).eResource();
					if (resource != null) {
						final ResourceSet resourceSet = resource
								.getResourceSet();
						if (resourceSet != null) {
							final Collection<EObject> visited = new HashSet<EObject>(
									eObjects);
							final Registry packageRegistry = resourceSet
									.getPackageRegistry();
							for (final String nsURI : packageRegistry
									.keySet()) {
								ItemPropertyDescriptor
										.collectReachableObjectsOfType(visited,
												eObjects,
												packageRegistry
														.getEPackage(nsURI),
												this.feature.getEType());
							}
						}
					}
					set.addAll(eObjects);
				}

				return set;
			}
		});

	}

	/**
	 * This adds a property descriptor for the Direction feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addDirectionPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_ActivityParameter_direction_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_ActivityParameter_direction_feature",
						"_UI_ActivityParameter_type"),
				MlsdmPackage.Literals.ACTIVITY_PARAMETER__DIRECTION, true,
				false, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null,
				null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(
			Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(
					MlcorePackage.Literals.ML_ANNOTATED_ELEMENT__ANNOTATIONS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns ActivityParameter.gif.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object,
				getResourceLocator().getImage("full/obj16/ActivityParameter"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public String getText(final Object object) {
		String label = this.getString("_UI_ActivityParameter_type");

		final ActivityParameter parameter = (ActivityParameter) object;

		label += " ";

		switch (parameter.getDirection()) {
			case IN :
				label += "in";
				break;
			case OUT :
				label += "out";
				break;
			case INOUT :
				label += "inout";
				break;
		}

		label += " ";

		if ((parameter.getName() != null) && !"".equals(parameter.getName())) {
			label += parameter.getName();
		} else {
			label += "[null]";
		}

		label += " : ";

		if (parameter.getType() != null) {
			label += parameter.getType().getName();
		} else {
			label += "[null]";
		}

		return label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ActivityParameter.class)) {
			case MlsdmPackage.ACTIVITY_PARAMETER__NAME :
			case MlsdmPackage.ACTIVITY_PARAMETER__TYPE :
			case MlsdmPackage.ACTIVITY_PARAMETER__DIRECTION :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), false, true));
				return;
			case MlsdmPackage.ACTIVITY_PARAMETER__ANNOTATIONS :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(
			Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(
				MlcorePackage.Literals.ML_ANNOTATED_ELEMENT__ANNOTATIONS,
				MlannotationsFactory.eINSTANCE.createMLAnnotation()));
	}

}
