/**
 */
package de.mdelab.mlsdm.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemColorProvider;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITableItemColorProvider;
import org.eclipse.emf.edit.provider.ITableItemFontProvider;
import org.eclipse.emf.edit.provider.ITableItemLabelProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlannotations.MlannotationsFactory;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.provider.MLElementWithUUIDItemProvider;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.Semaphore;

/**
 * This is the item provider adapter for a {@link de.mdelab.mlsdm.Semaphore} object.
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * @generated
 */
public class SemaphoreItemProvider extends MLElementWithUUIDItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public SemaphoreItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addTokenCountPropertyDescriptor(object);
			addAcquireEdgesPropertyDescriptor(object);
			addReleaseEdgesPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_MLNamedElement_name_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_MLNamedElement_name_feature",
						"_UI_MLNamedElement_type"),
				MlcorePackage.Literals.ML_NAMED_ELEMENT__NAME, true, false,
				false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Token Count feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addTokenCountPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_Semaphore_tokenCount_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_Semaphore_tokenCount_feature",
						"_UI_Semaphore_type"),
				MlsdmPackage.Literals.SEMAPHORE__TOKEN_COUNT, true, false,
				false, ItemPropertyDescriptor.INTEGRAL_VALUE_IMAGE, null,
				null));
	}

	/**
	 * This adds a property descriptor for the Acquire Edges feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addAcquireEdgesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_Semaphore_acquireEdges_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_Semaphore_acquireEdges_feature",
						"_UI_Semaphore_type"),
				MlsdmPackage.Literals.SEMAPHORE__ACQUIRE_EDGES, true, false,
				true, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Release Edges feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addReleaseEdgesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_Semaphore_releaseEdges_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_Semaphore_releaseEdges_feature",
						"_UI_Semaphore_type"),
				MlsdmPackage.Literals.SEMAPHORE__RELEASE_EDGES, true, false,
				true, null, null, null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(
			Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(
					MlcorePackage.Literals.ML_ANNOTATED_ELEMENT__ANNOTATIONS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Semaphore.gif.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object,
				getResourceLocator().getImage("full/obj16/Semaphore"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((Semaphore) object).getName();
		return label == null || label.length() == 0
				? getString("_UI_Semaphore_type")
				: getString("_UI_Semaphore_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Semaphore.class)) {
			case MlsdmPackage.SEMAPHORE__NAME :
			case MlsdmPackage.SEMAPHORE__TOKEN_COUNT :
			case MlsdmPackage.SEMAPHORE__ACQUIRE_EDGES :
			case MlsdmPackage.SEMAPHORE__RELEASE_EDGES :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), false, true));
				return;
			case MlsdmPackage.SEMAPHORE__ANNOTATIONS :
				fireNotifyChanged(new ViewerNotification(notification,
						notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(
			Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(
				MlcorePackage.Literals.ML_ANNOTATED_ELEMENT__ANNOTATIONS,
				MlannotationsFactory.eINSTANCE.createMLAnnotation()));
	}

}
